/********************************************************************
 FileName:     	usb_descriptors.c
 Dependencies:	See INCLUDES section
 Processor:		PIC18 or PIC24 USB Microcontrollers
 Hardware:		The code is natively intended to be used on the following
 				hardware platforms: PICDEMEFS USB Demo Board, 
 				PIC18F87J50 FS USB Plug-In Module, or
 				Explorer 16 + PIC24 USB PIM.  The firmware may be
 				modified for use on other USB platforms by editing the
 				HardwareProfile.h file.
 Complier:  	Microchip C18 (for PIC18) or C30 (for PIC24)
 Company:		Microchip Technology, Inc.

 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(r) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************************
*  MPLAB(R) XC8 C Compiler Version 1.00                                        *
*  XC8 CompilerpɕύX                             BY ޒH[(2013-09-07)  *
*******************************************************************************/

#ifndef __USB_DESCRIPTORS_C
#define __USB_DESCRIPTORS_C

#include "./USB/usb.h"
#include "./USB/usb_function_cdc.h"

/**************************/
/* foCXfBXNv^ */
/**************************/
ROM USB_DEVICE_DESCRIPTOR device_dsc=
{
    0x12,                   // ̃foCXfBXNv^̃TCY(18byte)
    USB_DESCRIPTOR_DEVICE,  // fBXNv^ނ́H(0x01="foCXfBXNv^")
    0x0200,                 // trão[W(BCD\LFUSB2.0)
    CDC_DEVICE,             // NXR[h(0x02:Communications Device Class = CDCNX)
    0x00,                   // TuNXR[h()
    0x00,                   // vgR[R[h()
    USB_EP0_BUFF_SIZE,      // Gh|CgO̍őpPbgTCY(8byte)
    0x04D8,                 // x_ hc(USB IF 犄ĂĖႤo^ꂽԍ)
    0x000A,                 // v_Nghc : CDC RS-232 Emulation Demo
    0x0100,                 // foCX̃o[W(BCD\LFVer1.00)
    0x01,                   // ҂̃XgOւ̃CfbNXԍ
    0x02,                   // ĩXgOւ̃CfbNXԍ
    0x00,                   // ԍ̃XgOւ̃CfbNXԍ()
    0x01                    // RtBM[VfBXNv̍\
};

/****************************************/
/* RtBM[VfBXNv^ */
/****************************************/
ROM BYTE configDescriptor1[]={
    /* RtBM[VfBXNv^ */
    0x09,                          // ̃RtBM[VfBXNv^̃TCY(9byte)
    USB_DESCRIPTOR_CONFIGURATION,  // fBXNv^ނ́H(0x02="RtBM[VfBXNv^")
    67,0,                          // Configuration,Interface,Endpoint Descriptor ܂ޑS̒(67byte)
    2,                             // ̍\C^[tF[XfBXNv̐
    1,                             // ̃RtBM[VfBXNv^̃CfbNXԍ
    0,                             // ̍\́AXgOւ̃CfbNXԍ()
    _DEFAULT | _SELF,              // d̍\(USBoX狟 OR Ztd)
//    _DEFAULT | _SELF | _RWU,       // [gEGCNAbv@\Lɂꍇ̋Lq
    50,                            // USBoX狟ꍇ̍őd (2x mAF50x2=100mA)
							
    /* C^[tF[XfBXNv^ */
    0x09,                          // ̃C^[tF[XfBXNv^̃TCY(9byte)
    USB_DESCRIPTOR_INTERFACE,      // fBXNv^ނ́H(0x04="C^[tF[XfBXNv^")
    0,                             // C^[tF[XfBXNv^̎ʔԍ
    0,                             // ̃C^[tF[Xŕ̐ݒꍇɎʂׂ̔ԍ()
    1,                             // ̃C^[tF[XGh|Cǧ
    COMM_INTF,                     // NXR[h(0x02:CDCNX)
    ABSTRACT_CONTROL_MODEL,        // TuNXR[h(0x02:Abstract Control Model)
    V25TER,                        // vgR[R[h(0x01:ITU-T V.250 ATR}h: V.250)
    0,                             // ̍\́AXgOւ̃CfbNXԍ()

    /* CDCNXŗL̋@\fBXNv^ */
    // wb_[@\̋Lq
    sizeof(USB_CDC_HEADER_FN_DSC), // ̍\̃TCY(5byte)
    CS_INTERFACE,                  // ̍\̎ނ́H(0x24="C^[tF[X")
    DSC_FN_HEADER,                 // @\?(0x00="wb_[@\")
    0x10,0x01,                     // CDC̃o[W

    // Ǘ@\̊TOLq
    sizeof(USB_CDC_ACM_FN_DSC),    // ̍\̃TCY(4byte)
    CS_INTERFACE,                  // ̍\̎ނ́H(0x24="C^[tF[X")
    DSC_FN_ACM,                    // @\?(0x02="Ǘ@\̊TO")
    USB_CDC_ACM_FN_DSC_VAL,        // ʐMC̐IvVƎvH

    // L@\̋Lq
    sizeof(USB_CDC_UNION_FN_DSC),  // ̍\̃TCY(5byte)
    CS_INTERFACE,                  // ̍\̎ނ́H(0x24="C^[tF[X")
    DSC_FN_UNION,                  // @\?(0x06="L@\")
    CDC_COMM_INTF_ID,              // "Communications Class interface"̃C^[tF[Xԍ(0x00)
    CDC_DATA_INTF_ID,              // "Data Class interface"̃C^[tF[Xԍ(0x01)

    // Ǘ@\̋LqĂяo
    sizeof(USB_CDC_CALL_MGT_FN_DSC),    // ̍\̃TCY(5byte)
    CS_INTERFACE,                       // ̍\̎ނ́H(0x24="C^[tF[X")
    DSC_FN_CALL_MGT,                    // @\?(0x01="Ǘ@\̋LqĂяo")
    0x00,                               // 
    CDC_DATA_INTF_ID,                   // "Data Class interface"̃C^[tF[Xԍ(0x01)

    /* Gh|CgfBXNv^ */
    0x07,                          // ̃Gh|CgfBXNv^̃TCY(7byte)
    USB_DESCRIPTOR_ENDPOINT,       // fBXNv^ނ́H(0x05="Gh|CgfBXNv^")
    _EP01_IN,                      // Gh|Cg͓͂ŃGh|Cgʔԍ͂P
    _INTERRUPT,                    // ][h́AC^vg]
    0x08,0x00,                     // ̃Gh|Cg̍őpPbgTCY(8byte)
    0x02,                          // zXg|[Os(2 msec)

    /* C^[tF[XfBXNv^ */
    0x09,                          // ̃C^[tF[XfBXNv^̃TCY(9byte)
    USB_DESCRIPTOR_INTERFACE,      // fBXNv^ނ́H(0x04="C^[tF[XfBXNv^")
    1,                             // C^[tF[XfBXNv^̎ʔԍ
    0,                             // ̐ݒꍇɎʂׂ̔ԍ()
    2,                             // ̃C^[tF[XGh|Cǧ
    DATA_INTF,                     // NXR[h(0x0a:f[^C^[tFCX)
    0,                             // TuNXR[h()
    NO_PROTOCOL,                   // vgR[R[h(0x00:vgR[͖)
    0,                             // ̍\́AXgOւ̃CfbNXԍ()
    
    /* Gh|CgfBXNv^ */
    0x07,                          // ̃Gh|CgfBXNv^̃TCY(7byte)
    USB_DESCRIPTOR_ENDPOINT,       // fBXNv^ނ́H(0x05="Gh|CgfBXNv^")
    _EP02_OUT,                     // Gh|Cg͏o͂ŃGh|Cgʔԍ͂Q
    _BULK,                         // ][h́AoN]
    0x40,0x00,                     // ̃Gh|Cg̍őpPbgTCY(64byte)
    0x00,                          // zXg|[Os͖

    /* Gh|CgfBXNv^ */
    0x07,                          // ̃Gh|CgfBXNv^̃TCY(7byte)
    USB_DESCRIPTOR_ENDPOINT,       // fBXNv^ނ́H(0x05="Gh|CgfBXNv^")
    _EP02_IN,                      // Gh|Cg͓͂ŃGh|Cgʔԍ͂Q
    _BULK,                         // ][h́AoN]
    0x40,0x00,                     // ̃Gh|Cg̍őpPbgTCY(64byte)
    0x00,                          // zXg|[Os͖
};

/****************************/
/* XgOfBXNv^ */
/****************************/

// R[h̕fBXNv^(#00)
ROM struct{
         BYTE bLength;
         BYTE bDscType;
         WORD string[1];
    } sd000 = {
         sizeof(sd000),            // ̃fBXNv^̃TCY
         USB_DESCRIPTOR_STRING,    // fBXNv^ނ́H(0x03)
         {0x0409}                  // XgŐLq́AAJp\
    };
// ҂̃XgO(#01)
ROM struct{
         BYTE bLength;
         BYTE bDscType;
         WORD string[25];
    } sd001 = { 
         sizeof(sd001),            // ̃fBXNv^̃TCY
         USB_DESCRIPTOR_STRING,    // fBXNv^ނ́H(0x03)
         {'M','i','c','r','o','c','h','i','p',' ','T','e','c','h','n','o','l','o','g','y',' ','I','n','c','.'}
    };
// ĩXgO(#02)
ROM struct{
         BYTE bLength;
         BYTE bDscType;
         WORD string[25];
    } sd002 = {
         sizeof(sd002),            // ̃fBXNv^̃TCY
         USB_DESCRIPTOR_STRING,    // fBXNv^ނ́H(0x03)
         {'C','D','C',' ','R','S','-','2','3','2',' ','E','m','u','l','a','t','i','o','n',' ','D','e','m','o'}
    };

//Array of configuration descriptors
ROM BYTE *ROM USB_CD_Ptr[]=
{
    (ROM BYTE *ROM)&configDescriptor1
};
//Array of string descriptors
ROM BYTE *ROM USB_SD_Ptr[USB_NUM_STRING_DESCRIPTORS]=
{
    (ROM BYTE *ROM)&sd000,
    (ROM BYTE *ROM)&sd001,
    (ROM BYTE *ROM)&sd002
};

#endif
