/********************************************************************************
  File Information:
    FileName:       usb_function_cdc.c
    Dependencies:   See INCLUDES section
    Processor:      PIC18 or PIC24 USB Microcontrollers
    Hardware:       The code is natively intended to be used on the following
                    hardware platforms: PICDEM(TM) FS USB Demo Board,
                    PIC18F87J50 FS USB Plug-In Module, or
                    Explorer 16 + PIC24 USB PIM.  The firmware may be
                    modified for use on other USB platforms by editing the
                    HardwareProfile.h file.
    Complier:   Microchip C18 (for PIC18) or C30 (for PIC24)
    Company:        Microchip Technology, Inc.

    Software License Agreement:

    The software supplied herewith by Microchip Technology Incorporated
    (the "Company") for its PIC(R) Microcontroller is intended and
    supplied to you, the Company's customer, for use solely and
    exclusively on Microchip PIC Microcontroller products. The
    software is owned by the Company and/or its supplier, and is
    protected under applicable copyright laws. All rights are reserved.
    Any use in violation of the foregoing restrictions may subject the
    user to criminal sanctions under applicable laws, as well as to
    civil liability for the breach of the terms and conditions of this
    license.

    THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
    WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
    TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
    PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
    IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
    CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

----------------------------------------------------------------------------------

  :
    ̃t@Cɂ́A֐A}NA`AϐAf[^^ȂǂׂĊ܂܂Ă܂B
    ́ACDC@\hCogp߂ɕKvƂB
    ̃t@ĆACDC@\̃hCogpvWFNgɊ܂܂ׂłB

********************************************************************************
*  ̃t@ĆA18F14K50XC8 C CompilerpɕύXĂ܂B                *
*  ܂ACDCNXɕKvȂƎvꕔ̋@\EIvV폜Ă܂B *
********************************************************************************
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2013-09-07  ޒH[     Create                                 *
* ============================================================================ *
*  PIC 18F14K50(Hdq̂traΉ^}CR{[h)                      *
*  MPLAB IDE(V8.84)                                                            *
*  MPLAB(R) XC8 C Compiler Version 1.00                                        *
*******************************************************************************/
#include "USB/usb.h"
#include "USB/usb_function_cdc.h"
#include "HardwareProfile - PIC18F14K50.h"

#ifdef USB_USE_CDC

/** V A R I A B L E S ********************************************************/
// cdc_data_rx[]cdc_data_tx[]zƊ֘Aϐ́A
// ̃t@[EFAłUSBpPbgobt@ƂĎgp܂B
// āAނ́A}CNRg[RAMUSBW[\ɔzuKv܂B

#if defined(__XC8)
        #define IN_DATA_BUFFER_ADDRESS 0x260
        #define OUT_DATA_BUFFER_ADDRESS (IN_DATA_BUFFER_ADDRESS + CDC_DATA_IN_EP_SIZE)
        #define LINE_CODING_ADDRESS (OUT_DATA_BUFFER_ADDRESS + CDC_DATA_OUT_EP_SIZE)
        #define NOTICE_ADDRESS (LINE_CODING_ADDRESS + LINE_CODING_LENGTH)

        #define IN_DATA_BUFFER_ADDRESS_TAG  @IN_DATA_BUFFER_ADDRESS
        #define OUT_DATA_BUFFER_ADDRESS_TAG @OUT_DATA_BUFFER_ADDRESS
        #define LINE_CODING_ADDRESS_TAG     @LINE_CODING_ADDRESS
        #define NOTICE_ADDRESS_TAG          @NOTICE_ADDRESS
#else
    #define IN_DATA_BUFFER_ADDRESS_TAG
    #define OUT_DATA_BUFFER_ADDRESS_TAG
    #define LINE_CODING_ADDRESS_TAG
    #define NOTICE_ADDRESS_TAG
#endif

volatile unsigned char cdc_data_tx[CDC_DATA_IN_EP_SIZE] IN_DATA_BUFFER_ADDRESS_TAG;
volatile unsigned char cdc_data_rx[CDC_DATA_OUT_EP_SIZE] OUT_DATA_BUFFER_ADDRESS_TAG;

LINE_CODING line_coding LINE_CODING_ADDRESS_TAG;    // Ci[obt@
volatile CDC_NOTICE cdc_notice NOTICE_ADDRESS_TAG; // CDCʒm

#if defined(USB_CDC_SUPPORT_DSR_REPORTING)          // DSRIvVݖ
    SERIAL_STATE_NOTIFICATION SerialStatePacket;
#endif

BYTE cdc_rx_len;              // total rx length

BYTE cdc_trf_state;           // bcb]̏
POINTER pCDCSrc;              // Mf[^̕ۑAhX
POINTER pCDCDst;              // Dedicated destination pointer
BYTE cdc_tx_len;              // Mf[^̒
BYTE cdc_mem_type;            // Mf[^̕ۑ惁̃^Cv(_ROM, _RAM)

USB_HANDLE CDCDataOutHandle;  // EP2(f[^]p)OUTp̃obt@OfBXNv^̃|C^
USB_HANDLE CDCDataInHandle;   // EP2(f[^]p) INp̃obt@OfBXNv^̃|C^


CONTROL_SIGNAL_BITMAP control_signal_bitmap;
DWORD BaudRateGen;			// BRG value calculated from baudrate

#if defined(USB_CDC_SUPPORT_DSR_REPORTING)
    BM_SERIAL_STATE SerialStateBitmap;
    BM_SERIAL_STATE OldSerialStateBitmap;
    USB_HANDLE CDCNotificationInHandle;
#endif

// SEND_ENCAPSULATED_COMMANDGET_ENCAPSULATED_RESPONSE̗v́ACDCdlɏ]ĕKvƂB
// Aۂɂ̓_~[obt@L邾Ȃ̂ŁAŎgpĂȂB
#define dummy_length    0x08
BYTE_VAL dummy_encapsulated_cmd_response[dummy_length];

#if defined(USB_CDC_SET_LINE_CODING_HANDLER)
CTRL_TRF_RETURN USB_CDC_SET_LINE_CODING_HANDLER(CTRL_TRF_PARAMS);
#endif

/** P R I V A T E  P R O T O T Y P E S ***************************************/
void USBCDCSetLineCoding(void);

/** C L A S S  S P E C I F I C  R E Q *****************************************/

/*******************************************************************************
*  void USBCheckCDCRequest(void)                                               *
*    CDCNXŗL̃NGXgƒʒm̗v֐                       *
*    SETUPpPbgzXg瓞ɂ̂݁A̋@\ďoKv܂ *
*******************************************************************************/
void USBCheckCDCRequest(void)
{
    // NGXg^Cv̎M҂[C^[tFCX]`FbN
    if(SetupPkt.Recipient != USB_SETUP_RECIPIENT_INTERFACE_BITFIELD) return;

    // NGXg^Cv[NXNGXg]`FbN
    if(SetupPkt.RequestType != USB_SETUP_TYPE_CLASS_BITFIELD) return;

    // C^[tF[XfBXNv^̎ʔԍ`FbN
    if((SetupPkt.bIntfID != CDC_COMM_INTF_ID)&&
       (SetupPkt.bIntfID != CDC_DATA_INTF_ID)) return;

    // C^[tFCXXfBXNv^ɑ΂ev̏s
    switch(SetupPkt.bRequest)
    {
        case SEND_ENCAPSULATED_COMMAND:      // vgR̃R}h𔭍s
            // _~[f[^𑗂Ă邾
            inPipes[0].pSrc.bRam  = (BYTE*)&dummy_encapsulated_cmd_response;
            inPipes[0].wCount.Val = dummy_length;
            inPipes[0].info.bits.ctrl_trf_mem = USB_EP0_RAM;
            inPipes[0].info.bits.busy = 1;
            break;
        case GET_ENCAPSULATED_RESPONSE:      // vgR̉v
            // _~[f[^𑗂Ă邾
            inPipes[0].pSrc.bRam      = (BYTE*)&dummy_encapsulated_cmd_response;
            inPipes[0].info.bits.busy = 1;
            break;

        #if defined(USB_CDC_SUPPORT_ABSTRACT_CONTROL_MANAGEMENT_CAPABILITIES_D1)
        case SET_LINE_CODING:                // ʐMxEXgbvrbgEpeBẼrbgݒ
            outPipes[0].wCount.Val     = SetupPkt.wLength;
            outPipes[0].pDst.bRam      = (BYTE*)LINE_CODING_TARGET;
            outPipes[0].pFunc          = LINE_CODING_PFUNC;
            outPipes[0].info.bits.busy = 1;
            break;
        case GET_LINE_CODING:                // ʐMxEXgbvrbgEpeBẼrbg̐ݒ擾
            USBEP0SendRAMPtr( (BYTE*)&line_coding, LINE_CODING_LENGTH, USB_EP0_INCLUDE_ZERO);
            break;
        case SET_CONTROL_LINE_STATE:         // RTS / CTSt[̎{
            control_signal_bitmap._byte = (BYTE)SetupPkt.W_Value.v[0];
            //CONFIGURE_RTS(control_signal_bitmap.CARRIER_CONTROL);  
            #if defined(USB_CDC_SUPPORT_DTR_SIGNALING)
                if(control_signal_bitmap.DTE_PRESENT == 1) {
                    UART_DTR = USB_CDC_DTR_ACTIVE_LEVEL;
                } else {
                    UART_DTR = (USB_CDC_DTR_ACTIVE_LEVEL ^ 1);
                }        
            #endif
            inPipes[0].info.bits.busy = 1;
            break;
        #endif

        #if defined(USB_CDC_SUPPORT_ABSTRACT_CONTROL_MANAGEMENT_CAPABILITIES_D2)
        case SEND_BREAK:                     // u[N
            inPipes[0].info.bits.busy = 1;
            if (SetupPkt.wValue == 0xFFFF) {
                // M̒~
                UART_Tx     = 0;   // TXLOWiu[NVOiOpj쓮邽߂̏
                UART_TRISTx = 0;   // TXs͏o
                UART_ENABLE = 0;   //iTXs̐jUSARTItɂ
            } else if (SetupPkt.wValue == 0x0000) {
                // ĊJ
                UART_ENABLE = 1;   // USARTIɂ
                UART_TRISTx = 1;   // TXs
            } else {
                // (SetupPkt.wValue)ms bԂ~
                UART_SEND_BREAK(); // ̊֐ȂlHH
            }
            break;
        #endif
        default:
            break;
    }

}

/** U S E R  A P I ************************************************************/

/*******************************************************************************
*  void CDCInitEP(void)                                                        *
*    pGh|Cg(EP0ȊO)̏s֐                           *
*    bcbNXŗL̏s                                            *
*    SET_CONFIGURATIONR}ȟɌĂяoȂ΂Ȃ܂B               *
*******************************************************************************/
void CDCInitEP(void)
{
    // Abstract Contro Mode ̏ݒ
    line_coding.dwDTERate.Val = 19200;       // baud rate
    line_coding.bCharFormat   = 0x00;        // 1 stop bit
    line_coding.bParityType   = 0x00;        // None
    line_coding.bDataBits     = 0x08;        // 5,6,7,8, or 16

    cdc_rx_len = 0;

    // Gh|CgʔԍP̐ݒs(C^vg])
    // [IN L][Gh|Cg̃nhVFCNL][Xg[Ȃ]
    // [Rg[]𖳌AIN or OUT ]̂݋]
    USBEnableEndpoint(CDC_COMM_EP,USB_IN_ENABLED|USB_HANDSHAKE_ENABLED|USB_DISALLOW_SETUP);
    // Gh|CgʔԍQ̐ݒs(oN])
    // [IN  OUT L][Gh|Cg̃nhVFCNL][Xg[Ȃ]
    // [Rg[]𖳌AIN or OUT ]̂݋]
    USBEnableEndpoint(CDC_DATA_EP,USB_IN_ENABLED|USB_OUT_ENABLED|USB_HANDSHAKE_ENABLED|USB_DISALLOW_SETUP);
    // OUTgUNV(M)ׂ̈ɃfARAMobt@(BDTɐݒ)܂
    CDCDataOutHandle = USBRxOnePacket(CDC_DATA_EP,(BYTE*)&cdc_data_rx,sizeof(cdc_data_rx));
    CDCDataInHandle  = NULL;

    // MC̃t[sȂ珉sȂ
    #if defined(USB_CDC_SUPPORT_DSR_REPORTING)
        CDCNotificationInHandle = NULL;
        mInitDTSPin();  //Configure DTS as a digital input
      	SerialStateBitmap.byte = 0x00;
      	OldSerialStateBitmap.byte = !SerialStateBitmap.byte;    //To force firmware to send an initial serial state packet to the host.
        //Prepare a SerialState notification element packet (contains info like DSR state)
        SerialStatePacket.bmRequestType = 0xA1; //Always 0xA1 for this type of packet.
        SerialStatePacket.bNotification = SERIAL_STATE;
        SerialStatePacket.wValue = 0x0000;  //Always 0x0000 for this type of packet
        SerialStatePacket.wIndex = CDC_COMM_INTF_ID;  //Interface number  
        SerialStatePacket.SerialState.byte = 0x00;
        SerialStatePacket.Reserved = 0x00;
        SerialStatePacket.wLength = 0x02;   //Always 2 bytes for this type of packet    
        CDCNotificationHandler();
    #endif
    #if defined(USB_CDC_SUPPORT_DTR_SIGNALING)
        mInitDTRPin();
    #endif
    #if defined(USB_CDC_SUPPORT_HARDWARE_FLOW_CONTROL)
        mInitRTSPin();
        mInitCTSPin();
    #endif

    cdc_trf_state = CDC_TX_READY;       // Mnj
}


/*******************************************************************************
*  void CDCNotificationHandler(void)                                           *
*    DSȐԂ̕ω`FbNAUSBzXgɕ񍐂֐                      *
*    "#define USB_CDC_SUPPORT_DSR_REPORTING"IvVLɂȂĂꍇA *
*    IDSRsTvOAUSBzXgɏ𑗂邽߂ɌĂяo܂B*
*    (݂̓IvV͖ƂȂĂ)                                      *
*******************************************************************************/
#if defined(USB_CDC_SUPPORT_DSR_REPORTING)
void CDCNotificationHandler(void)
{
    // DTS I/Os`FbNAԕωoꂽꍇA
    // VAԒʒmfqpPbg𑗐M邱ƂɂAUSBzXgɒʒmB

    // UART_DTŚADTS@\gpׂ̃n[hEFAvt@CI/Os̗lɒ`܂(ݖ`)B
    if(UART_DTS == USB_CDC_DSR_ACTIVE_LEVEL) {
        SerialStateBitmap.bits.DSR = 1;
    } else {
        SerialStateBitmap.bits.DSR = 0;
    }

    //ԂύXAGh|Cgp\łꍇAUSBzXgɕω̒ʒmpPbg𑗐MB
    if((SerialStateBitmap.byte != OldSerialStateBitmap.byte) && (!USBHandleBusy(CDCNotificationInHandle)))
    {
        // MUSBpPbgobt@ɍXVꂽlRs[܂B
        // ̑̃f[^͏l̂܂܂ŕύX͂Ȃ
        SerialStatePacket.SerialState.byte = SerialStateBitmap.byte;
        // USBoRŃzXgɃpPbg𑗐M܂B
        CDCNotificationInHandle = USBTransferOnePacket(CDC_COMM_EP, IN_TO_HOST, (BYTE*)&SerialStatePacket, sizeof(SERIAL_STATE_NOTIFICATION));
        // Âlۑ܂̂ŁAŕύXo邱Ƃł܂B
        OldSerialStateBitmap.byte = SerialStateBitmap.byte;
    }
}
#else
    #define CDCNotificationHandler() {} // IvV͖Ȃ疳
#endif


/*******************************************************************************
*  BYTE getsUSBUSART(char *buffer, BYTE len)                                   *
*    w肵ꏊOUTGh|CĎMoCgRs[֐ *
*    p\ȃf[^݂Ȃꍇ́A'0 'ԂB                        *
*                                                                              *
*    *buffer : MꂽoCgi[ꏊւ̃|C^                      *
*    len     : Gh|Cg̍ő]TCY                                  *
*******************************************************************************/
BYTE getsUSBUSART(char *buffer, BYTE len)
{
    cdc_rx_len = 0;

    // EP2OUT(f[^])pBDT̃Xe[^XWX^[`FbN(I[i[SIEłȂ)
    if(!USBHandleBusy(CDCDataOutHandle)) {
        // ۂɎMTCYlen菭ȂȂAlen𒲐
        if (len > USBHandleGetLength(CDCDataOutHandle)) len = USBHandleGetLength(CDCDataOutHandle);

        // [U[̃obt@ɃfARAMobt@f[^Rs[
        for (cdc_rx_len = 0; cdc_rx_len < len; cdc_rx_len++) {
            buffer[cdc_rx_len] = cdc_data_rx[cdc_rx_len];
        }

        // OUTgUNVׂ̈ɃfARAMobt@(BDTɐݒ)܂
        CDCDataOutHandle = USBRxOnePacket(CDC_DATA_EP,(BYTE*)&cdc_data_rx,sizeof(cdc_data_rx));
    }

    return cdc_rx_len;
}


/*******************************************************************************
*  void putUSBUSART(char *data, BYTE  length)                                  *
*    Mf[^̔zwoCgZbg֐                      *
*    zXgɃf[^̃ubN𑗐MׂɁA                              *
*    CDCTxService()IɌĂяoȂ΂Ȃ܂B                      *
*                                                                              *
*    *data  : Mf[^RAM̔zւ̊i[AhXw肷              *
*    length : Mf[^̃oCgw肷A(255łȂ΂Ȃ܂)*
*******************************************************************************/
void putUSBUSART(char *data, BYTE  length)
{
    USBMaskInterrupts();                          // tra荞݂̋֎~
    if(cdc_trf_state == CDC_TX_READY)
    {
        mUSBUSARTTxRam((BYTE*)data, length);      // Mf[^̃Zbgs
    }
    USBUnmaskInterrupts();                        // tra荞݂̋
}


/*******************************************************************************
*  void pustUSBUSART(char *data)                                               *
*    M镶̔z0x00܂ŃZbg֐                              *
*    zXgɃf[^̃ubN𑗐MׂɁA                              *
*    CDCTxService()IɌĂяoȂ΂Ȃ܂B                      *
*                                                                              *
*    *data  : M镶RAM̔zւ̊i[AhXw肷              *
*             M镶f[^̍ő咷255łȂ΂Ȃ܂        *
*******************************************************************************/
void putsUSBUSART(char *data)
{
    BYTE len;
    char *pData;

    USBMaskInterrupts();                // tra荞݂̋֎~
    if(cdc_trf_state != CDC_TX_READY) {
        USBUnmaskInterrupts();          // tra荞݂̋
        return;
    }

    // null character(0x00) ܂ł̕𒲂ׂ
    len = 0;
    pData = data;
    do
    {
        len++;
        if(len == 255) break;           // ő255܂łȂ̂ŏI
    }while(*pData++);

    mUSBUSARTTxRam((BYTE*)data, len);   // Mf[^̃Zbgs
    USBUnmaskInterrupts();              // tra荞݂̋
}


/*******************************************************************************
*  void CDCTxService(void)                                                     *
*    foCXzXgւ̂bcbʐMgUNV֐            *
*    ʐMf[^ݒ肳ꂽԂɓBA                                  *
*    ̊֐́ACvÕ[vƂɈxĂяoȂ΂Ȃ܂B*
*******************************************************************************/
void CDCTxService(void)
{
    BYTE byte_to_send;
    BYTE i;

    USBMaskInterrupts();                          // tra荞݂̋֎~

    // crq(݂̃IvV͖Œ`Ă)
    CDCNotificationHandler();
    // EP2IN(f[^])pBDT̃Xe[^XWX^[`FbN
    if(USBHandleBusy(CDCDataInHandle)) {          // I[i[SIEłASIE
        USBUnmaskInterrupts();                    // tra荞݂̋
        return;
    }

    // bcbʐMԂ""Ȃ"fB"Ƃ
    if(cdc_trf_state == CDC_TX_COMPLETING) cdc_trf_state = CDC_TX_READY ;
    // bcbʐMԂ"fB"Ȃ牽ȂŖ߂
    if(cdc_trf_state == CDC_TX_READY) {
        USBUnmaskInterrupts();                    // tra荞݂̋
        return;
    }

    if(cdc_trf_state == CDC_TX_BUSY_ZLP) {
        // f[^ÕpPbg𑗐Mꍇ
        CDCDataInHandle = USBTxOnePacket(CDC_DATA_EP,NULL,0);    // BDT(IN EP2:DATA)ɃZbg
        //CDC_DATA_BD_IN.CNT = 0;
        cdc_trf_state = CDC_TX_COMPLETING;                       // M
    }
    else if(cdc_trf_state == CDC_TX_BUSY)
    {
        // bcbʐMԂ"M"̏ꍇ
        // Mf[^͑Mobt@蒷̂`FbN
    	if(cdc_tx_len > sizeof(cdc_data_tx)) byte_to_send = sizeof(cdc_data_tx);
    	else                                 byte_to_send = cdc_tx_len;
        // Mc̃oCgvZ
        cdc_tx_len = cdc_tx_len - byte_to_send;

        // Mobt@Ƀf[^Rs[
        pCDCDst.bRam = (BYTE*)&cdc_data_tx;       // Mobt@̃AhXݒ
        i = byte_to_send;                         // 񑗐Mf[^JԂ
        if(cdc_mem_type == USB_EP0_ROM) {         // Mf[^̊i[惁͂qnlɊi[Ă
            while(i) {
                *pCDCDst.bRam = *pCDCSrc.bRom;
                pCDCDst.bRam++;
                pCDCSrc.bRom++;
                i--;
            }
        } else {                                  // \[X͂q`lɊi[Ă
            while(i) {
                *pCDCDst.bRam = *pCDCSrc.bRam;
                pCDCDst.bRam++;
                pCDCSrc.bRam++;
                i--;
            }
        }

        // f[^̑Ms
        if(cdc_tx_len == 0) {
            // Mf[^͂ȏȂꍇ
            // Mf[^AMobt@TCYƓȂ玟ɒÕpPbg𑗐MAȊO͏I
            if(byte_to_send == CDC_DATA_IN_EP_SIZE) cdc_trf_state = CDC_TX_BUSY_ZLP;
            else                                    cdc_trf_state = CDC_TX_COMPLETING;
        }
        CDCDataInHandle = USBTxOnePacket(CDC_DATA_EP,(BYTE*)&cdc_data_tx,byte_to_send);   // BDT(IN EP2:DATA)ɃZbg
    }

    USBUnmaskInterrupts();                        // tra荞݂̋
}

#endif //USB_USE_CDC
