/********************************************************************
 FileName:     	usb_descriptors.c
 Dependencies:  See INCLUDES section
 Processor:	    PIC18, PIC24, dsPIC, and PIC32 USB Microcontrollers
 Hardware:      This demo is natively intended to be used on Microchip USB demo
                boards supported by the MCHPFSUSB stack.  See release notes for
                support matrix.  This demo can be modified for use on other 
                hardware platforms.
 Complier:  	Microchip C18 (for PIC18), C30 (for PIC24/33), C32 (for PIC32)
 Company:		Microchip Technology, Inc.

 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************************
*  MPLAB(R) XC8 C Compiler Version 1.00                                        *
*  XC8 CompilerpɕύX                             BY ޒH[(2013-09-16)  *
*******************************************************************************/

#ifndef __USB_DESCRIPTORS_C
#define __USB_DESCRIPTORS_C

/** INCLUDES *******************************************************/
#include "./USB/usb.h"
#include "./USB/usb_function_hid.h"

/** CONSTANTS ******************************************************/

/**************************/
/* foCXfBXNv^ */
/**************************/
ROM USB_DEVICE_DESCRIPTOR device_dsc=
{
    0x12,                   // ̃foCXfBXNv^̃TCY(18byte)
    USB_DESCRIPTOR_DEVICE,  // fBXNv^ނ́H(0x01="foCXfBXNv^")
    0x0200,                 // trão[W(BCD\LFUSB2.0)
    0x00,                   // NXR[h((0x00:HIDNX)
    0x00,                   // TuNXR[h()
    0x00,                   // vgR[R[h()
    USB_EP0_BUFF_SIZE,      // Gh|CgO̍őpPbgTCY(8byte)
    MY_VID,                 // x_ hc(USB IF 犄ĂĖႤo^ꂽԍ)
    MY_PID,                 // v_Nghc : Keyboard fw demo
    0x0001,                 // foCX̃o[W(BCD\LFVer1.00)
    0x01,                   // ҂̃XgOւ̃CfbNXԍ
    0x02,                   // ĩXgOւ̃CfbNXԍ
    0x00,                   // ԍ̃XgOւ̃CfbNXԍ()
    0x01                    // RtBM[VfBXNv̍\
};

/****************************************/
/* RtBM[VfBXNv^ */
/****************************************/
ROM BYTE configDescriptor1[]={
    /* RtBM[VfBXNv^ */
    0x09,                          // ̃RtBM[VfBXNv^̃TCY(9byte)
    USB_DESCRIPTOR_CONFIGURATION,  // fBXNv^ނ́H(0x02="RtBM[VfBXNv^")
    DESC_CONFIG_WORD(0x0029),      // Configuration,Interface,Endpoint Descriptor ܂ޑS̒(29byte)
    1,                             // ̍\C^[tF[XfBXNv̐
    1,                             // ̃RtBM[VfBXNv^̃CfbNXԍ
    0,                             // ̍\́AXgOւ̃CfbNXԍ()
    _DEFAULT | _SELF | _RWU,       // d̍\(USBoX狟 OR Ztd OR [gEGCNAbv@\)
    50,                            // USBoX狟ꍇ̍őd (2x mAF50x2=100mA)

    /* C^[tF[XfBXNv^ */
    0x09,                          // ̃C^[tF[XfBXNv^̃TCY(9byte)
    USB_DESCRIPTOR_INTERFACE,      // fBXNv^ނ́H(0x04="C^[tF[XfBXNv^")
    0,                             // C^[tF[XfBXNv^̎ʔԍ
    0,                             // ̃C^[tF[Xŕ̐ݒꍇɎʂׂ̔ԍ()
    2,                             // ̃C^[tF[XGh|Cǧ
    HID_INTF,                      // NXR[h(0x03:HIDNX)
    BOOT_INTF_SUBCLASS,            // TuNXR[h(0x01:Boot Interface subclass 0x00:None)
    HID_PROTOCOL_KEYBOARD,         // vgR[R[h(0x01:L[{[h 0x02:}EX 0x00:None)
    0,                             // ̍\́AXgOւ̃CfbNXԍ()

    /* HIDNXŗL̋@\fBXNv^ */
    0x09,                          // ̍\̃TCY(9byte)
    DSC_HID,                       // ̍\̎ނ́H(0x21:HID)
    DESC_CONFIG_WORD(0x0111),      // HIDdl̃Xԍ(BCD:Ver1.11)
    0x00,                          // n[hEGA[JCYꂽ̔ԍ(BCD)(0x00͖)
    HID_NUM_OF_DSC,                // HIDNXfBXNv^̐(0x01)
    DSC_RPT,                       // NXfBXNv^̎(0x22:|[g)
    DESC_CONFIG_WORD(63),          // |[gfBXNv^̒(63byte)
    
    /* Gh|CgfBXNv^ */
    0x07,                          // ̃Gh|CgfBXNv^̃TCY(7byte)
    USB_DESCRIPTOR_ENDPOINT,       // fBXNv^ނ́H(0x05="Gh|CgfBXNv^")
    HID_EP | _EP_IN,               // Gh|Cg̃AhXƕ(PIN)
    _INTERRUPT,                    // ][h́AC^vg]
    DESC_CONFIG_WORD(8),           // ̃Gh|Cg̍őpPbgTCY(8byte)
    0x01,                          // zXg|[Os(1 msec)

    /* Gh|CgfBXNv^ */
    0x07,                          // ̃Gh|CgfBXNv^̃TCY(7byte)
    USB_DESCRIPTOR_ENDPOINT,       // fBXNv^ނ́H(0x05="Gh|CgfBXNv^")
    HID_EP | _EP_OUT,              // Gh|Cg̃AhXƕ(POUT)
    _INTERRUPT,                    // ][h́AC^vg]
    DESC_CONFIG_WORD(8),           // ̃Gh|Cg̍őpPbgTCY(8byte)
    0x01,                          // zXg|[Os(1 msec)

};

/****************************/
/* XgOfBXNv^ */
/****************************/

// R[h̕fBXNv^(#00)
ROM struct{
         BYTE bLength;
         BYTE bDscType;
         WORD string[1];
    } sd000 = {
         sizeof(sd000),           // ̃fBXNv^̃TCY
         USB_DESCRIPTOR_STRING,    // fBXNv^ނ́H(0x03)
         {0x0409}                  // XgŐLq́AAJp\
    };

// ҂̃XgO(#01)
ROM struct{
         BYTE bLength;
         BYTE bDscType;
         WORD string[25];
    } sd001 = {
         sizeof(sd001),           // ̃fBXNv^̃TCY
         USB_DESCRIPTOR_STRING,    // fBXNv^ނ́H(0x03)
         {'M','i','c','r','o','c','h','i','p',' ','T','e','c','h','n','o','l','o','g','y',' ','I','n','c','.'}
    };

// ĩXgO(#02)
ROM struct{
         BYTE bLength;
         BYTE bDscType;
         WORD string[13];
    } sd002 = {
         sizeof(sd002),           // ̃fBXNv^̃TCY
         USB_DESCRIPTOR_STRING,    // fBXNv^ނ́H(0x03)
         {'K','e','y','b','o','a','r','d',' ','D','e','m','o'}
    };

/**************************************************/
/* HIDNX|[gfBXNv^ - HID Keyboard */
/**************************************************/

// zXg֕񍐂L[{[h@\̓e
// zXgƃfoCXԂőMf[^̃tH[}bg`ׂ̃fBXNv^łB
ROM struct{
         BYTE report[HID_RPT01_SIZE];
    } hid_rpt01 = {
   {0x05, 0x01,                    // USAGE_PAGE (Generic Desktop)
    0x09, 0x06,                    // USAGE (Keyboard)

    0xa1, 0x01,                    // COLLECTION (Application)

    0x05, 0x07,                    //   USAGE_PAGE (Keyboard)
    0x19, 0xe0,                    //   USAGE_MINIMUM (Keyboard LeftControl)
    0x29, 0xe7,                    //   USAGE_MAXIMUM (Keyboard Right GUI)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x25, 0x01,                    //   LOGICAL_MAXIMUM (1)
    0x75, 0x01,                    //   REPORT_SIZE (1)
    0x95, 0x08,                    //   REPORT_COUNT (8)
    0x81, 0x02,                    //   INPUT (Data,Var,Abs)
    0x95, 0x01,                    //   REPORT_COUNT (1)
    0x75, 0x08,                    //   REPORT_SIZE (8)
    0x81, 0x03,                    //   INPUT (Cnst,Var,Abs)

    0x95, 0x05,                    //   REPORT_COUNT (5)
    0x75, 0x01,                    //   REPORT_SIZE (1)
    0x05, 0x08,                    //   USAGE_PAGE (LEDs)
    0x19, 0x01,                    //   USAGE_MINIMUM (Num Lock)
    0x29, 0x05,                    //   USAGE_MAXIMUM (Kana)
    0x91, 0x02,                    //   OUTPUT (Data,Var,Abs)
    0x95, 0x01,                    //   REPORT_COUNT (1)
    0x75, 0x03,                    //   REPORT_SIZE (3)
    0x91, 0x03,                    //   OUTPUT (Cnst,Var,Abs)

    0x95, 0x06,                    //   REPORT_COUNT (6)
    0x75, 0x08,                    //   REPORT_SIZE (8)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x25, 0x65,                    //   LOGICAL_MAXIMUM (101)
    0x05, 0x07,                    //   USAGE_PAGE (Keyboard)
    0x19, 0x00,                    //   USAGE_MINIMUM (Reserved (no event indicated))
    0x29, 0x65,                    //   USAGE_MAXIMUM (Keyboard Application)
    0x81, 0x00,                    //   INPUT (Data,Ary,Abs)

    0xc0}                          // End Collection
    };

//Array of configuration descriptors
ROM BYTE *ROM USB_CD_Ptr[]=
{
    (ROM BYTE *ROM)&configDescriptor1
};

//Array of string descriptors
ROM BYTE *ROM USB_SD_Ptr[]=
{
    (ROM BYTE *ROM)&sd000,
    (ROM BYTE *ROM)&sd001,
    (ROM BYTE *ROM)&sd002
};

/** EOF usb_descriptors.c ***************************************************/

#endif
