/********************************************************************
  File Information:
    FileName:     	usb_function_hid.c
    Dependencies:   See INCLUDES section
    Processor:      PIC18 or PIC24 USB Microcontrollers
    Hardware:       The code is natively intended to be used on the following
    				hardware platforms: PICDEME FS USB Demo Board, 
    				PIC18F87J50 FS USB Plug-In Module, or
    				Explorer 16 + PIC24 USB PIM.  The firmware may be
    				modified for use on other USB platforms by editing the
    				HardwareProfile.h file.
    Complier:  	    Microchip C18 (for PIC18) or C30 (for PIC24)
    Company:        Microchip Technology, Inc.
    
    Software License Agreement:
    
    The software supplied herewith by Microchip Technology Incorporated
    (the "Company") for its PIC(R) Microcontroller is intended and
    supplied to you, the Company's customer, for use solely and
    exclusively on Microchip PIC Microcontroller products. The
    software is owned by the Company and/or its supplier, and is
    protected under applicable copyright laws. All rights are reserved.
    Any use in violation of the foregoing restrictions may subject the
    user to criminal sanctions under applicable laws, as well as to
    civil liability for the breach of the terms and conditions of this
    license.
    
    THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
    WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
    TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
    PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
    IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
    CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

----------------------------------------------------------------------------------


  :
    ̃t@Cɂ́A֐A}NA`AϐAf[^^ȂǂׂĊ܂܂Ă܂B
    ́AHID@\hCogp߂ɕKvƂB
    ̃t@ĆAHID@\̃hCogpvWFNgɊ܂܂ׂłB

********************************************************************************
*  ̃t@ĆA{RgɕύXĂ邾łB                      *
********************************************************************************
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2013-09-07  ޒH[     Create                                 *
* ============================================================================ *
*  PIC 18F14K50(Hdq̂traΉ^}CR{[h)                      *
*  MPLAB IDE(V8.84)                                                            *
*  MPLAB(R) XC8 C Compiler Version 1.00                                        *
*******************************************************************************/
#ifndef USB_FUNCTION_HID_C
#define USB_FUNCTION_HID_C

/** INCLUDES *******************************************************/
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "./USB/usb.h"
#include "./USB/usb_function_hid.h"


/** VARIABLES ******************************************************/

BYTE idle_rate;
BYTE active_protocol;   // [0] Boot Protocol [1] Report Protocol

/** EXTERNAL PROTOTYPES ********************************************/
#if defined USER_GET_REPORT_HANDLER
    void USER_GET_REPORT_HANDLER(void);
#endif

#if defined USER_SET_REPORT_HANDLER
    void USER_SET_REPORT_HANDLER(void);
#endif     

/** Section: DECLARATIONS ***************************************************/

/** Section: CLASS SPECIFIC REQUESTS ****************************************/

/*******************************************************************************
*  void USBCheckHIDRequest(void)                                               *
*    HIDNXŗL̃NGXgƒʒm̗v֐                       *
*    SETUPpPbgzXg瓞ɂ̂݁A̋@\ďoKv܂ *
*******************************************************************************/
void USBCheckHIDRequest(void)
{
    // SETUPpPbg̎M҂C^[tFCXłȂȂ珈ȂŖ߂
    if(SetupPkt.Recipient != USB_SETUP_RECIPIENT_INTERFACE_BITFIELD) return ;
    // C^[tFCXʔԍOłȂȂ珈ȂŖ߂
    if(SetupPkt.bIntfID != HID_INTF_ID) return ;

    // zXgGET_DESCRIPTOR̗vȂ珈
    if(SetupPkt.bRequest == USB_REQUEST_GET_DESCRIPTOR)
    {
        switch(SetupPkt.bDescriptorType) {
            case DSC_HID:     // HIDNXŗL̋@\fBXNv^
                if(USBActiveConfiguration == 1) {
                    USBEP0SendROMPtr(
                        (ROM BYTE*)&configDescriptor1 + 18,
                        sizeof(USB_HID_DSC)+3,
                        USB_EP0_INCLUDE_ZERO);
                }
                break;
            case DSC_RPT:     // HIDNX|[gfBXNv^
                //if(USBActiveConfiguration == 1) 
                {
                    USBEP0SendROMPtr(
                        (ROM BYTE*)&hid_rpt01,
                        HID_RPT01_SIZE,
                        USB_EP0_INCLUDE_ZERO);
                }
                break;
            case DSC_PHY:     // HIDtBWJfBXNv^
                // foCXgpl̑̂̕ʂɊւ镨Iȏ`܂B
                // ̗v̓IvVłAʏHID̃AvP[Vł͎gp܂B
                // ̗vꍇ͌STALLԂ܂B
                // ꍇ́Aȉ̃Rg܂AA`f[^͋LqȂłB
                //if(USBActiveConfiguration == 1)
                //{
                //    USBEP0SendROMPtr((ROM BYTE*)&hid_phy01, sizeof(hid_phy01), USB_EP0_INCLUDE_ZERO);
                //}
                break;
        }
    }

    // NXւ̗vłȂȂ߂
    if(SetupPkt.RequestType != USB_SETUP_TYPE_CLASS_BITFIELD) return ;

    switch(SetupPkt.bRequest)
    {
        case GET_REPORT:      // HIDf[^Ԃ
            #if defined USER_GET_REPORT_HANDLER
                USER_GET_REPORT_HANDLER();   // ݂̊֐͖
            #endif
            break;
        case SET_REPORT:      // zXgLED̏ԏ𑗂܂
            #if defined USER_SET_REPORT_HANDLER
                USER_SET_REPORT_HANDLER();
            #endif       
            break;
        case GET_IDLE:        // ݂̃ACh[gԂ
            USBEP0SendRAMPtr(
                (BYTE*)&idle_rate,
                1,
                USB_EP0_INCLUDE_ZERO);
            break;
        case SET_IDLE:        // |[g𑗐MACh[g(Ԋu)ݒ
            USBEP0Transmit(USB_EP0_NO_DATA);
            idle_rate = SetupPkt.W_Value.byte.HB;
            break;
        case GET_PROTOCOL:    // ݑIĂvgRR[hԂ
            USBEP0SendRAMPtr(
                (BYTE*)&active_protocol,
                1,
                USB_EP0_NO_OPTIONS);
            break;
        case SET_PROTOCOL:    // gpvgRR[h̐ݒ
            USBEP0Transmit(USB_EP0_NO_DATA);
            active_protocol = SetupPkt.W_Value.byte.LB;
            break;
    }
}


/********************************************************************
    Function:
        USB_HANDLE HIDTxPacket(BYTE ep, BYTE* data, WORD len)
        
    Summary:
        Sends the specified data out the specified endpoint

    Description:
        This function sends the specified data out the specified 
        endpoint and returns a handle to the transfer information.

        Typical Usage:
        <code>
        //make sure that the last transfer isn't busy by checking the handle
        if(!HIDTxHandleBusy(USBInHandle))
        {
            //Send the data contained in the ToSendDataBuffer[] array out on
            //  endpoint HID_EP
            USBInHandle = HIDTxPacket(HID_EP,(BYTE*)&ToSendDataBuffer[0],sizeof(ToSendDataBuffer));
        }
        </code>
        
    PreCondition:
        None
        
    Parameters:
        BYTE ep    - the endpoint you want to send the data out of
        BYTE* data - pointer to the data that you wish to send
        WORD len   - the length of the data that you wish to send
        
    Return Values:
        USB_HANDLE - a handle for the transfer.  This information
        should be kept to track the status of the transfer
        
    Remarks:
        None
  
 *******************************************************************/
 // Implemented as a macro. See usb_function_hid.h

/********************************************************************
    Function:
        USB_HANDLE HIDRxPacket(BYTE ep, BYTE* data, WORD len)
        
    Summary:
        Receives the specified data out the specified endpoint
        
    Description:
        Receives the specified data out the specified endpoint.

        Typical Usage:
        <code>
        //Read 64-bytes from endpoint HID_EP, into the ReceivedDataBuffer array.
        //  Make sure to save the return handle so that we can check it later
        //  to determine when the transfer is complete.
        USBOutHandle = HIDRxPacket(HID_EP,(BYTE*)&ReceivedDataBuffer,64);
        </code>

    PreCondition:
        None
        
    Parameters:
        BYTE ep    - the endpoint you want to receive the data into
        BYTE* data - pointer to where the data will go when it arrives
        WORD len   - the length of the data that you wish to receive
        
    Return Values:
        USB_HANDLE - a handle for the transfer.  This information
        should be kept to track the status of the transfer
        
    Remarks:
        None
  
 *******************************************************************/
  // Implemented as a macro. See usb_function_hid.h
  
/** USER API *******************************************************/

#endif
/** EOF usb_function_hid.c ******************************************************/
