/********************************************************************
  File Information:
    FileName:     	usb_device.c
    Dependencies:	See INCLUDES section
    Processor:		PIC18,PIC24, PIC32 and dsPIC33E USB Microcontrollers
    Hardware:		This code is natively intended to be used on Mirochip USB
                    demo boards.  See www.microchip.com/usb (Software & Tools 
                    section) for list of available platforms.  The firmware may 
                    be modified for use on other USB platforms by editing the
    				HardwareProfile.h and HardwareProfile - [platform].h files.
    Complier:  	    Microchip C18 (for PIC18),C30 (for PIC24 and dsPIC33E)
                    and C32 (for PIC32)
    Company:		Microchip Technology, Inc.
    
    Software License Agreement:
    
    The software supplied herewith by Microchip Technology Incorporated
    (the "Company") for its PIC(r) Microcontroller is intended and
    supplied to you, the Company's customer, for use solely and
    exclusively on Microchip PIC Microcontroller products. The
    software is owned by the Company and/or its supplier, and is
    protected under applicable copyright laws. All rights are reserved.
    Any use in violation of the foregoing restrictions may subject the
    user to criminal sanctions under applicable laws, as well as to
    civil liability for the breach of the terms and conditions of this
    license.
    
    THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
    WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
    TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
    PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
    IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
    CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

----------------------------------------------------------------------------------

  :
    płꂽAPI֐/}N̐́AMCHPFSUSBCuwvɋL
    USBAPIhLg͈ȉ猩邱Ƃł܂F
    Start menu --> (All Programs) --> Microchip --> MCHPFSUSB vX.x --> Documents --> MCHPFSUSB Library Help
    wvt@CJƁAAPI֐/}ŃÃZNVŐĂ܂F
    CuC^[tF[XiAPIj - >foCX/Ӌ@ - >foCXX^bN - >C^tF[X[`
    ǉAPI@\ꂽUSBfoCXNXɉĒ񋟂ĂA

********************************************************************************
*  ̃t@ĆA18F14K50XC8 C CompilerpɕύXĂ܂B                *
*  ܂AĂ삷Ǝvꕔ̋@\EIvV폜Ă܂B    *
********************************************************************************
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.01     2013-09-07  ޒH[     Create                                 *
* ============================================================================ *
*  PIC 18F14K50(Hdq̂traΉ^}CR{[h)                      *
*  MPLAB IDE(V8.84)                                                            *
*  MPLAB(R) XC8 C Compiler Version 1.00                                        *
*******************************************************************************/
#include "./USB/usb.h"
#include "HardwareProfile - PIC18F14K50.h"
#include "./USB/usb_device_local.h"


// USBoX(D+/D-)̒[qĎ̂߂tO
// dUSBoXŖȂ"USE_USB_BUS_SENSE_IO"𐶂܂B
#if !defined(USE_USB_BUS_SENSE_IO)
    #undef USB_BUS_SENSE
    #define USB_BUS_SENSE 1                                 // ɓdnmԂɐݒ肵Ēu
#endif
// f[^gO͗L(pPbg̃peBDTS̒lƍ)
#define _DTS_CHECKING_ENABLED _DTSEN

// ϐ̒`
USB_VOLATILE USB_DEVICE_STATE USBDeviceState;               // USBfoCX̓ڍs(Xe[g)Ԃi[ϐ
USB_VOLATILE BYTE USBActiveConfiguration;                   // RtBM[VfBXNv^ւ̃CfbNXԍ
USB_VOLATILE BYTE USBAlternateInterface[USB_MAX_NUM_INT];   // I^l[gC^[tFCX
volatile BDT_ENTRY *pBDTEntryEP0OutCurrent;                 // EPO OUTBDT(Crrent)ւ̃Gg[|C^
volatile BDT_ENTRY *pBDTEntryEP0OutNext;                    // EPO OUTBDT(Next)ւ̃Gg[|C^
volatile BDT_ENTRY *pBDTEntryOut[USB_MAX_EP_NUMBER+1];      // OUTBDTւ̃Gg[|C^
volatile BDT_ENTRY *pBDTEntryIn[USB_MAX_EP_NUMBER+1];       // INBDTւ̃Gg[|C^
USB_VOLATILE BYTE shortPacketStatus;                        // V[gpPbg(MZŌ̃pPbg)̑M
USB_VOLATILE BYTE controlTransferState;                     // Rg[]̓]
USB_VOLATILE IN_PIPE inPipes[1];                            // Mׂ̃f[^i[
USB_VOLATILE OUT_PIPE outPipes[1];                          // Mׂ̃f[^i[
USB_VOLATILE BYTE *pDst;
USB_VOLATILE BOOL RemoteWakeup;                             // [gEFCNAbv̗LtO
USB_VOLATILE BOOL USBBusIsSuspended ;                       // zXg̃TXyhԂtO
USB_VOLATILE USTAT_FIELDS USTATcopy;                        // USTAT USBXe[^XWX^Uۑϐ
USB_VOLATILE BYTE endpoint_number;                          // USTAT ̃Gh|CgԍUۑϐ
USB_VOLATILE BOOL BothEP0OutUOWNsSet;
USB_VOLATILE EP_STATUS ep_data_in[USB_MAX_EP_NUMBER+1];     // hmGh|Cg̏Ԃi[
USB_VOLATILE EP_STATUS ep_data_out[USB_MAX_EP_NUMBER+1];    // ntsGh|Cg̏Ԃi[
USB_VOLATILE BYTE USBStatusStageTimeoutCounter;             // Xe[^XXe[W̐isԃJE^
volatile BOOL USBDeferStatusStagePacket;
volatile BOOL USBStatusStageEnabledFlag1;                   // 
volatile BOOL USBStatusStageEnabledFlag2;                   // 
volatile BOOL USBDeferINDataStagePackets;                   // 
volatile BOOL USBDeferOUTDataStagePackets;                   // 

// obt@ fBXNv^ e[ǔvZ
// USB_PING_PONG__FULL_PING_PONG = SẴGh|Cgŋ/s|obt@Lɂ
// USB_MAX_EP_NUMBER = QFgpGh|Cǧ(EP1/EP2)
#if (USB_PING_PONG_MODE == USB_PING_PONG__NO_PING_PONG)
    #define BDT_NUM_ENTRIES      ((USB_MAX_EP_NUMBER + 1) * 2)
#elif (USB_PING_PONG_MODE == USB_PING_PONG__EP0_OUT_ONLY)
    #define BDT_NUM_ENTRIES      (((USB_MAX_EP_NUMBER + 1) * 2)+1)
#elif (USB_PING_PONG_MODE == USB_PING_PONG__FULL_PING_PONG)
    #define BDT_NUM_ENTRIES      ((USB_MAX_EP_NUMBER + 1) * 4)   // ((2 + EP0) * 4) = 12
#elif (USB_PING_PONG_MODE == USB_PING_PONG__ALL_BUT_EP0)
    #define BDT_NUM_ENTRIES      (((USB_MAX_EP_NUMBER + 1) * 4)-2)
#else
    #error "No ping pong mode defined."
#endif


// obt@ fBXNv^ e[ůmۂs(EP0/EP1/EP2)
volatile BDT_ENTRY BDT[BDT_NUM_ENTRIES] @USB_BDT_ADDRESS;            // 4WX^ x 12(48byte)

// doOp̎Mf[^obt@̊mۂs
volatile CTRL_TRF_SETUP SetupPkt @CTRL_TRF_SETUP_ADDR_TAG;             // 8byte
volatile BYTE CtrlTrfData[USB_EP0_BUFF_SIZE] @CTRL_TRF_DATA_ADDR_TAG;  // 8byte


// O錾ϐ
////Depricated in v2.2 - will be removed in a future revision
#if !defined(USB_USER_DEVICE_DESCRIPTOR)
    // foCXfBXNv^
    extern ROM USB_DEVICE_DESCRIPTOR device_dsc;
#else
    USB_USER_DEVICE_DESCRIPTOR_INCLUDE;
#endif

#if !defined(USB_USER_CONFIG_DESCRIPTOR)
    // RtBM[VfBXNv^
    extern ROM BYTE *ROM USB_CD_Ptr[];
#else
    USB_USER_CONFIG_DESCRIPTOR_INCLUDE;
#endif

// XgOfBXNv^
extern ROM BYTE *ROM USB_SD_Ptr[];


//́AKvȃ[U[Cxgnh̊Ovg^Cvł
BOOL USER_USB_CALLBACK_EVENT_HANDLER(int event, void *pdata, WORD size);

// ֐vg^Cv̐錾
static void USBCtrlEPService(void);
static void USBCtrlTrfSetupHandler(void);
static void USBCtrlTrfInHandler(void);
static void USBCheckStdRequest(void);
static void USBStdGetDscHandler(void);
static void USBCtrlEPServiceComplete(void);
static void USBCtrlTrfTxService(void);
static void USBCtrlTrfRxService(void);
static void USBStdSetCfgHandler(void);
//static void USBStdGetStatusHandler(void);
static void USBStdFeatureReqHandler(void);
static void USBCtrlTrfOutHandler(void);
static void USBConfigureEndpoint(BYTE EPNum, BYTE direction);
static void USBWakeFromSuspend(void);
static void USBSuspend(void);
static void USBStallHandler(void);


/******************************************************************************/
/**  }N ***************************************************************/
/******************************************************************************/

/*******************************************************************************
*  USBAdvancePingPongBuffer(BDT_ENTRY** buffer)                                *
*    obt@fBXNv^e[ũ|C^ɐi߂鏈                  *
*    ̊֐́As|IvV̐ݒɊÂāA                          *
*    nꂽBDT_ENTRY|C^ւ̎̃obt@Ƀ|C^i߂܂B           *
*    ̋@\́AEP1-EP15Ŏgp܂AEP0̂߂ɗLł͂܂B         *
*                                                                              *
*    **buffer : i߂BDT_ENTRY|C^ւ̃|C^                          *
*******************************************************************************/
#define USBAdvancePingPongBuffer(buffer) ((BYTE_VAL*)buffer)->Val ^= USB_NEXT_PING_PONG;
#define USBHALPingPongSetToOdd(buffer)   {((BYTE_VAL*)buffer)->Val |= USB_NEXT_PING_PONG;}
#define USBHALPingPongSetToEven(buffer)  {((BYTE_VAL*)buffer)->Val &= ~USB_NEXT_PING_PONG;}


/******************************************************************************/
/** O API ֐ *************************************************************/
/******************************************************************************/

/*******************************************************************************
*  void USBDeviceInit(void)                                                    *
*    traW[̏s                                        *
*******************************************************************************/
void USBDeviceInit(void)
{
    BYTE i;

    // WX^̃NAƐݒ菈
    PIE2bits.USBIE = 0 ;                     // trȃS̊荞݂֎~ɂ
    UEIR = 0 ;                               // traG[荞݃tONA
    UIR  = 0 ;                               // traCxg荞݃tONA
    UEP0 = 0 ;                               // Gh|CgO䃌WX^NA
    // gp镪̃Gh|Cg䃌WX^NA( EP1 EP2)
    memset((void*)&UEP1,0x00,USB_MAX_EP_NUMBER) ;
    // vAbvLAtXs[hASẴGh|CgŃs|obt@Lɐݒ
    UCFG = 0b00010100 | USB_PING_PONG_MODE ;
    UEIE = 0b10011111 ;                      // traG[荞݂Sċ
    UIE  = 0b00111011 | USB_SOF_INTERRUPT ;  // traCxg荞ݑSċ

    // obt@fBXNv^e[uNA
    for(i=0;i<(sizeof(BDT)/sizeof(BDT_ENTRY));i++) {
        BDT[i].Val = 0x00;
    }

    UCONbits.PPBRST = 1 ;                    // s|obt@|C^Zbg(obt@ɐݒ)
    UADDR = 0 ;                              // traAhXWX^Zbg
    UCONbits.PKTDIS = 0 ;                    // pPbg̑MLɂ
    UCONbits.PPBRST = 0 ;                    // s|obt@|C^̃Zbg~

    // M̃gUNV΃tbV
    while(UIRbits.TRNIF == 1) {
        UIRbits.TRNIF = 0 ;
        // USBX^bN\tgEFȀԕϐ
        inPipes[0].info.Val    = 0;
        outPipes[0].info.Val   = 0;
        outPipes[0].wCount.Val = 0;
    }

    // Rg[]̃Xe[^XXe[W֐"USBCtrlEPAllowStatusStage()"̏lݒ肷
    USBStatusStageEnabledFlag1  = TRUE;
    USBStatusStageEnabledFlag2  = TRUE;
    // ̑̃tO
    USBDeferINDataStagePackets  = FALSE;     // 
    USBDeferOUTDataStagePackets = FALSE;     // 
    USBBusIsSuspended           = FALSE;     // zXgTXyh[hł͖Ɛݒ

    // obt@fBXNv^e[uւ̃Gg[|C^NA
    for(i = 0; i < (BYTE)(USB_MAX_EP_NUMBER+1u); i++) {
        pBDTEntryIn[i]     = 0u;
        pBDTEntryOut[i]    = 0u;
        ep_data_in[i].Val  = 0u;
        ep_data_out[i].Val = 0u;
    }

    // ŏ́AdoO̓͂ŋ̂acsւ̃Gg[|C^lŐݒ
    pBDTEntryIn[0] = (volatile BDT_ENTRY*)&BDT[EP0_IN_EVEN];
    // Gh|CgO䃌WX^̐ݒ
    // (MLEnhVFCNLERg[]LEXg[Ȃ)
    UEP0 = 0b00010110 ;
    // doȌo͂ŋ̂acsցAŏ̃ZbgAbv̏
    BDT[EP0_OUT_EVEN].ADR = ConvertToPhysicalAddress(&SetupPkt); // doOp̎Mf[^obt@|C^Zbg
    BDT[EP0_OUT_EVEN].CNT = USB_EP0_BUFF_SIZE;                   // doO̍őpPbgTCY(8byte)Zbg
    BDT[EP0_OUT_EVEN].STAT.Val = _USIE|_DAT0|_BSTALL; // SIEI[i[EDATA0Eobt@Xg[LEf[^gO

    // RtBM[VfBXNv^̃CfbNXԍOɐݒ
    USBActiveConfiguration = 0;     

    // USBfoCX̏ԂoXɐڑĂȂ(vAbvڑ͖)Ƃ
    USBDeviceState = DETACHED_STATE;
}


/*******************************************************************************
  Function:
        void USBDeviceTasks(void)

  v:
    lXUSBoXECxgƃzXgvoяSB
    USBX^bN̎ȃfBXpb`[`łB
    ̊֐́AUSB enumeration vZXɊ֘AtĂRg[]̏A
    lXUSB̃Cxgo@\łB

    "USB_POLLING"[hœ삳ꍇ́AX^bNʂăpPbg𑗎M邽߂
    USBDeviceTasks() ֐IɌĂяoKv܂B
    ̎Å֐́AUSB enumeration vZXɏȂƂ 1.8ms ɌĂяoKv܂B

    "USB_INTERRUPT"[hō쓮Ă鎞́AC[vUSBDeviceTasks(jĂяoKv͂܂B
    USBDeviceTasks(jUSB荞݂ɎsKvA
    ̂߂荞݃ReLXgĂяoKv܂B

  l:
    botRATXyh[h畜Aꍇ́A10ms̃W[񕜊ԊuUSBdl݂B
    botRAX[vԂɂȂꍇłAUSBDeviceTasks(j֐́A܂IɌĂяoKv܂B

    USBP[uOĂ邩AVBUSCɓd͂ĂȂꍇ́AAvP[Vt@[EFA͏ɁA
    pɂ USBDeviceTasks() ĂяoKv͂܂B
    USBDeviceTasks(jIɌĂяoȂꍇAdꂽƂɑ₩ɌoiKv
    Ȃ܂̓fAZt/oXp[USBAvP[Vł́AUSBDeviceAttach()  USBDeviceDetach() 
    APIhLg̒ǉQlɂĉB

*******************************************************************************/
void USBDeviceTasks(void)
{
    BYTE i;

#if defined(USB_POLLING)
    // traoXdneeȂ炱̏sAoX؂藣ԂƂȂ
    // nmɂȂɉ"traoXɐڑ鏈"sB
    if (USB_BUS_SENSE != 1) {
         // traW[𖳌ɂăoX؂藣
         UCON = 0;            // USB 䃌WX^̃Zbg(traW[H)
         UIE  = 0;            // traCxg荞ݑSċ֎~ɂ
         // USBfoCX̏ԂoXɐڑĂȂ(vAbvڑ͖)Ƃ
         USBDeviceState = DETACHED_STATE;
         // traS̊荞݃tONA
         PIR2bits.USBIF = 0 ;
         return ;
    }

    // y USBfoCX̏ԁFoXɐڑĂȂ z
    //    traoXɐڑ鏈s
    if(USBDeviceState == DETACHED_STATE) {
         UCON = 0;            // USB 䃌WX^̃Zbg
         UIE  = 0;            // traCxg荞ݑSăZbg
         // vAbvLAtXs[hASẴGh|CgŃs|obt@Lɐݒ
         UCFG = 0b00010100 | USB_PING_PONG_MODE ;
         UEIE = 0b10011111 ;                      // traG[荞݂Sċ
         UIE  = 0b00111011 | USB_SOF_INTERRUPT ;  // traCxg荞ݑSċ

        // oXɐڑ鏈
        while (!UCONbits.USBEN){
             UCONbits.USBEN = 1 ;                 // traW[HLAvAbvRڑ
        }
        // USBfoCX̏ԂoXɐڑꂽԂƂ
        USBDeviceState = ATTACHED_STATE;
    }
#endif

    // y USBfoCX̏ԁFoXɐڑꂽ z
    //    traZbgMołlɂ鏈
    if(USBDeviceState == ATTACHED_STATE) {
        // VOGhO̊Ď
        // VOGhOƂ D+/D- [qƂ LOW ȏԂ
        // VOGhOłȂȂ烊Zbg󂯓\ɂ鏈
        if (!UCONbits.SE0) {
            UIR  = 0 ;                  // traCxg荞݃tONA
            #if defined(USB_POLLING)
            UEIR = 0 ;                  // traG[荞݃tONA
            #endif
            UIEbits.URSTIE = 1;         // USB Zbg荞݂
            UIEbits.IDLEIE = 1;         // ACho荞݂
            // USBfoCX̏Ԃ𓮍\ԂƂ
            USBDeviceState = POWERED_STATE;
        }
    }

    // yD+/D- CŃANeBreBoz
    if(UIRbits.ACTVIF && UIEbits.ACTVIE) {
         // EFCNAbv̏s
         USBWakeFromSuspend();
    }

    // foCXTXyh[hɂꍇȉ̏͂Ȃ
    if(UCONbits.SUSPND == 1) {
         // traS̊荞݃tONA
         PIR2bits.USBIF = 0 ;
         return ;
    }

    // yUSB Zbgz
    // VOGhO 10ms ȏ㑱烊ZbgƂ
    if(UIRbits.URSTIF && UIEbits.URSTIE) {
        // traW[̏s
        USBDeviceInit();
        // trȃS̊荞݂
        PIE2bits.USBIE = 1 ;
        // USBfoCX̏Ԃ́AZbgMõftHgԂƂ
        USBDeviceState = DEFAULT_STATE;

        UIRbits.URSTIF = 0 ;  // traZbg荞݃tONA
    }

    // yAChԂoz
    if(UIRbits.IDLEIF && UIEbits.IDLEIE) {
        // 
        USBSuspend();

        UIRbits.IDLEIF = 0 ;   // AChԂ̌o荞݃tONA
    }

    // ySOF(Start-of-Frame)g[NMz
    if(UIRbits.SOFIF) {
        // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
        if(UIEbits.SOFIE) {
            USER_USB_CALLBACK_EVENT_HANDLER(EVENT_SOF,0,0);
        }
        UIRbits.SOFIF = 0 ;   // SOFg[N荞݃tONA

        #if defined(USB_ENABLE_STATUS_STAGE_TIMEOUTS)
            // Xe[^XXe[WJE^fNg
            if(USBStatusStageTimeoutCounter != 0u) {
                USBStatusStageTimeoutCounter--;
            }
            // ^CAEgAXe[^XXe[Ws
            if(USBStatusStageTimeoutCounter == 0) {
                USBCtrlEPAllowStatusStage();
            } 
        #endif
    }

     // ySTALL nhVFCN𑗐Mz
    if(UIRbits.STALLIF && UIEbits.STALLIE) {
        // EP0ŃXg[𑗐MꍇɁABDT ̃I[i SIE ̎AL CPU ɖ߂
        USBStallHandler();
    }

     // yUSB G[z
    if(UIRbits.UERRIF && UIEbits.UERRIE) {
        // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
        USB_ERROR_HANDLER(EVENT_BUS_ERROR,0,0);
        // USB G[荞݃tÕNAs
        // UEIRNAUIRbits.UERRIF͎IɃNA(PIC18̂)
        UEIR = 0 ;
    }

    // ܂traZbgoĂȂꍇȉ̏͂Ȃ
    if(USBDeviceState < DEFAULT_STATE) {
         // traS̊荞݃tONA
         PIR2bits.USBIF = 0 ;
         return ;
    }

    /*
     *  USBgUNV荞
     */
    if(UIEbits.TRNIE) {
         // USTATWX^͂Sobt@(FIFO)L̂ł̕JԂ
         for(i = 0; i < 4u; i++) {
              // gUNVtOnmȂ珈
              // tONA鎖ɂ莟 USTAT obt@Ɉڍs
              if(UIRbits.TRNIF) {
                   USTATcopy.Val   = USTAT ;                     // USTATWX^Uۑ
                   endpoint_number = USTATcopy.endpoint_number ; // ŌɃANeBreB̂Gh|Cgԍ
                   UIRbits.TRNIF   = 0 ;                         // gUNV荞݃tONA

                   // EP0 ȊÕs|obt@LɂȂĂȂ珈
                   #if (USB_PING_PONG_MODE == USB_PING_PONG__ALL_BUT_EP0) || (USB_PING_PONG_MODE == USB_PING_PONG__FULL_PING_PONG) 
                        if(USTATcopy.direction == OUT_FROM_HOST) {
                             // gUNV OUT ܂ SETUP g[N
                             ep_data_out[endpoint_number].bits.ping_pong_state ^= 1 ;// /𔽓]
                         } else {
                             // gUNV IN g[N
                             ep_data_in[endpoint_number].bits.ping_pong_state ^= 1 ; // /𔽓]
                         }
                   #endif

                   // Gh|Cg EP0 ̎ USBCtrlEPService() 
                   if(endpoint_number == 0) {
                       USBCtrlEPService();
                   } else {
                       // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
                       USB_TRANSFER_COMPLETE_HANDLER(EVENT_TRANSFER, (BYTE*)&USTATcopy.Val, 0);
                   }
              } else break ;
         }
    }

    // traS̊荞݃tONA
    PIR2bits.USBIF = 0 ;
}


/*******************************************************************************
*  void USBEnableEndpoint(ep, options)                                         *
*    w肳ꂽGh|Cg̐ݒs֐                                  *
*    w ep ɑ΂obt@fBXNv^e[uւ̃|C^lۑ  *
*                                                                              *
*    ep      : ݒ肷Gh|Cg̔ԍ                                    *
*    options : Gh|Cg䃌WX^̐ݒl                              *
*******************************************************************************/
void USBEnableEndpoint(BYTE ep, BYTE options)
{
    unsigned char* p;

    // w̃Gh|Cg͂ntsL肩`FbN
    if(options & USB_OUT_ENABLED) {
        // w̃Gh|Cgɑ΂BDTւ̃|C^ۑ
        // BDTXe[^XWX^Ƀf[^gOrbg(DTS)ݒ肷
        USBConfigureEndpoint(ep, OUT_FROM_HOST);
    }
    // w̃Gh|Cg͂hmL肩`FbN
    if(options & USB_IN_ENABLED) {
        // w̃Gh|Cgɑ΂BDTւ̃|C^ۑ
        // BDTXe[^XWX^Ƀf[^gOrbg(DTS)ݒ肷
        USBConfigureEndpoint(ep, IN_TO_HOST);
    }

    // Gh|Cg䃌WX^̐ݒs
     p = (unsigned char*)(&UEP0+ep);
    *p = options;
}


/*******************************************************************************
*  USB_HANDLE USBTransferOnePacket(BYTE ep,BYTE dir,BYTE* data,BYTE len)       *
*    eNXŗL̑Mׂ̈ɂacsɐݒ(USBGh|Cg)s֐ *
*    M(INgUNV)ׂɃf[^acsɐݒ肷              *
*    M(OUTgUNV)olɂacs                       *
*                                                                              *
*    ep    : ݒ肷Gh|Cg̔ԍ                                      *
*    dir   : ]̕AOUT_FROM_HOST(M)  IN_TO_HOST(M)             *
*    *data : f[^obt@̃AhX|C^[                                *
*    len   : INgUNVȂ瑗MKvf[^̒              *
*            OUTgUNVȂGh|CgŋLqꂽ傫ɐݒ     *
*******************************************************************************/
USB_HANDLE USBTransferOnePacket(BYTE ep,BYTE dir,BYTE* data,BYTE len)
{
    volatile BDT_ENTRY* handle;

    // obt@fBXNv^e[ũ|C^[𓾂
    if(dir != 0) {  // Gh|Cg͂̕hm
        handle = pBDTEntryIn[ep];
    } else {        // Gh|Cg͂̕nts
        handle = pBDTEntryOut[ep];
    }
    if (handle == 0) return 0 ;    // G[

    //KvɉāADTS̃rbg؂ւ
    #if (USB_PING_PONG_MODE == USB_PING_PONG__NO_PING_PONG)
        handle->STAT.Val ^= _DTSMASK ;
    #elif (USB_PING_PONG_MODE == USB_PING_PONG__EP0_OUT_ONLY)
        if (ep != 0) handle->STAT.Val ^= _DTSMASK ;
    #endif

    // f[^|C^Af[^ݒ肵AGh|CgLɂ
    handle->ADR = ConvertToPhysicalAddress(data);
    handle->CNT = len;
    handle->STAT.Val &= _DTSMASK;
    handle->STAT.Val |= _USIE | (_DTSEN & _DTS_CHECKING_ENABLED);

    // s|ړÎ߂Ɏ̃obt@|Cg܂B
    if(dir != OUT_FROM_HOST) {
        // INGh|Cĝ߂Ɏ̃obt@(E)Đ؂ւĒu
        USBAdvancePingPongBuffer(&pBDTEntryIn[ep]);      
    } else {
        // OUTGh|Cĝ߂Ɏ̃obt@(E)Đ؂ւĒu
        USBAdvancePingPongBuffer(&pBDTEntryOut[ep]);     
    }
    return (USB_HANDLE)handle;
}


/*******************************************************************************
*  void USBDeviceDetach(void)                                                  *
*    USB oXfoCX؂藣                                        *
*    USB_INTERRUPT`Ăꍇɂ̂݌ĂяoKv܂B           *
*    ܂Å֐mainij̃[vReLXgĂяoKv܂B  *
*    荞݃nh炱̊֐ĂяoȂłB                  *
*******************************************************************************/
#if defined(USB_INTERRUPT)
void USBDeviceDetach(void)
{
    // traW[𖳌ɂăoX؂藣
    UCON = 0;            // USB 䃌WX^̃Zbg(traW[H)
    UIE  = 0;            // traCxg荞ݑSċ֎~ɂ
    // USBfoCX̏ԂoXɐڑĂȂ(vAbvڑ͖)Ƃ
    USBDeviceState = DETACHED_STATE;
}
#endif


/*******************************************************************************
*  void USBDeviceAttach(void)                                                  *
*    USB oXɃfoCXڑ鏈                                          *
*    USB_INTERRUPT`Ăꍇɂ̂݌ĂяoKv܂B           *
*    ܂Å֐mainij̃[vReLXgĂяoKv܂B  *
*    荞݃nh炱̊֐ĂяoȂłB                  *
*******************************************************************************/
#if defined(USB_INTERRUPT)
void USBDeviceAttach(void)
{
    // traoXɐڑĂȂԂȂ珈
    if(USBDeviceState == DETACHED_STATE) {
        // traoX̓dnmȂ珈s
        if(USB_BUS_SENSE == 1) {
             UCON = 0;            // USB 䃌WX^̃Zbg
             UIE  = 0;            // traCxg荞ݑSăZbg
             // vAbvLAtXs[hASẴGh|CgŃs|obt@Lɐݒ
             UCFG = 0b00010100 | USB_PING_PONG_MODE ;
             UEIE = 0b10011111 ;                      // traG[荞݂Sċ
             UIE  = 0b00111011 | USB_SOF_INTERRUPT ;  // traCxg荞ݑSċ

             RCONbits.IPEN   = 1 ;                    // 荞݂ɑ΂Dxx̐ݒLɂ
             IPR2bits.USBIP  = 1 ;                    // USB 荞ݗDx"Dx"Ƃ
             PIE2bits.USBIE  = 1 ;                    // USB S̊荞݂
             INTCONbits.GIEH = 1 ;                    // Dx̊荞݂Sċ

             // oXɐڑ鏈
             while (!UCONbits.USBEN){
                  UCONbits.USBEN = 1 ;                // traW[HLAvAbvRڑ
             }
             // USBfoCX̏ԂoXɐڑꂽԂƂ
             USBDeviceState = ATTACHED_STATE;
        }
    }
}
#endif


/*******************************************************************************
*  void USBCtrlEPAllowStatusStage(void)                                        *
*    Xe[^XXe[WpPbg̑M                                      *
*    ̊֐́ARg[]̃Xe[^XXe[WpPbg                *
*    ł悤ɂ邽߂̓K؂ȁAIN EP0܂EP0 OUT܂B       *
*******************************************************************************/
void USBCtrlEPAllowStatusStage(void)
{
    //Check and set two flags, prior to actually modifying any BDT entries.
    //This double checking is necessary to make certain that 
    //USBCtrlEPAllowStatusStage() can be called twice simultaneously (ex: once 
    //in main loop context, while simultaneously getting an interrupt which 
    //tries to call USBCtrlEPAllowStatusStage() again, at the same time).
    if(USBStatusStageEnabledFlag1 == FALSE) {
        USBStatusStageEnabledFlag1 = TRUE;  
        if(USBStatusStageEnabledFlag2 == FALSE) {
            USBStatusStageEnabledFlag2 = TRUE;
        
            // Gh|Cg̎(IN/OUT)`FbN
            if(controlTransferState == CTRL_TRF_RX) {
                pBDTEntryIn[0]->CNT = 0;
                pBDTEntryIn[0]->STAT.Val = _USIE|_DAT1|(_DTSEN & _DTS_CHECKING_ENABLED);        
            } else if(controlTransferState == CTRL_TRF_TX) {
                BothEP0OutUOWNsSet = FALSE;	//CWP[^tOUSBCtrlTrfOutHandlerŎgpij
 
                //̃obt@is|obt@OEP0 OUTLɂȂĂꍇj́ASETUPpPbgM܂B
                #if((USB_PING_PONG_MODE == USB_PING_PONG__EP0_OUT_ONLY) || (USB_PING_PONG_MODE == USB_PING_PONG__FULL_PING_PONG))
                    pBDTEntryEP0OutCurrent->CNT = USB_EP0_BUFF_SIZE;
                    pBDTEntryEP0OutCurrent->ADR = ConvertToPhysicalAddress(&SetupPkt);
                    pBDTEntryEP0OutCurrent->STAT.Val = _USIE|_BSTALL; //SETUPgUNV󂯓悤ɁAGh|Cg
                    BothEP0OutUOWNsSet = TRUE;	//CWP[^tOUSBCtrlTrfOutHandlerŎgpij
                #endif

                //This EP0 OUT buffer receives the 0-byte OUT status stage packet.
                pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
                pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
                pBDTEntryEP0OutNext->STAT.Val = _USIE;           // Note: DTSEN is 0
            }
        }
    }
}   


/*******************************************************************************
*  void USBCtrlEPAllowDataStage(void)                                          *
*    Rg[]ɂf[^Xe[Wł̑M鏈      *
*    <setup><out>ȂpPbgMolEP0 OUTB               *
*    <setup><in>Ȃ瑗MpPbgf[^BDTɃZbgB                  *
*******************************************************************************/
void USBCtrlEPAllowDataStage(void)
{
    USBDeferINDataStagePackets = FALSE;
    USBDeferOUTDataStagePackets = FALSE;

    if(controlTransferState == CTRL_TRF_RX) {
        // f[^̎M : <setup><out><out>...<out><in>
        // f[^Xe[W̃V[PX̍ŏOUTf[^pPbgM悤EP0 OUTB
        pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
        pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&CtrlTrfData);
        pBDTEntryEP0OutNext->STAT.Val = _USIE|_DAT1|(_DTSEN & _DTS_CHECKING_ENABLED);
    } else {
        // f[^̑M : <setup><in><in>...<in><out>
        // Mf[^zXg̗v蒷ȂAzXg̗v钷ɂ
        if(SetupPkt.wLength < inPipes[0].wCount.Val) {
            inPipes[0].wCount.Val = SetupPkt.wLength;
        }
        // f[^PgUNVM鏀(ŏ̃gUNV)
        // ۂɂ́AINg[NM_SIEIɑM
        USBCtrlTrfTxService();
        pBDTEntryIn[0]->ADR = ConvertToPhysicalAddress(&CtrlTrfData);
        pBDTEntryIn[0]->STAT.Val = _USIE|_DAT1|(_DTSEN & _DTS_CHECKING_ENABLED);
    }
}


/******************************************************************************/
/** ֐ ******************************************************************/
/******************************************************************************/


/*******************************************************************************
*  void USBConfigureEndpoint(EPNum, direction)                                 *
*    w肳ꂽGh|Cg̃obt@fBXNv^e[u(BDT)|C^ۑ *
*    ƁABDT̃Xe[^XWX^Ƀf[^gOrbg̐ݒs֐       *
*                                                                              *
*    EPNum     : ݒ肷Gh|Cg̔ԍ                                  *
*    direction : ݒ肷Gh|C OUT or IN                              *
*******************************************************************************/
static void USBConfigureEndpoint(BYTE EPNum, BYTE direction)
{
    volatile BDT_ENTRY* handle;

    // ܂Ahandle ̓obt@fBXNv^e[u̐擪ɈʒuÂ
    handle = (volatile BDT_ENTRY*)&BDT[EP0_OUT_EVEN];
    // ɁAw̃Gh|Cgɑ΂obt@fBXNv^e[uɈʒuÂ
    handle += EP(EPNum,direction,0u);

    // acs̃Xe[^XWX^ݒ@obt@̃I[i[͂bot
    handle->STAT.UOWN = 0;

    // w̃Gh|Cgɑ΂acsւ̃|C^[ۑ
    if(direction == OUT_FROM_HOST) {
        pBDTEntryOut[EPNum] = handle;
    } else {
        pBDTEntryIn[EPNum] = handle;
    }

    // f[^gOrbg̐ݒ̓s|obt@̗LɂĈقȂ
    #if (USB_PING_PONG_MODE == USB_PING_PONG__FULL_PING_PONG)
        handle->STAT.DTS = 0;           // BDT DATA0 pPbg
        (handle+1)->STAT.DTS = 1;       // BDT DATA1 pPbg
    #elif (USB_PING_PONG_MODE == USB_PING_PONG__NO_PING_PONG)
        handle->STAT.DTS = 1;
    #elif (USB_PING_PONG_MODE == USB_PING_PONG__EP0_OUT_ONLY)
        if(EPNum != 0) {                // EP0 łȂ
            handle->STAT.DTS = 1;
        }
    #elif (USB_PING_PONG_MODE == USB_PING_PONG__ALL_BUT_EP0)    
        if(EPNum != 0) {
            handle->STAT.DTS = 0;
            (handle+1)->STAT.DTS = 1;
        }
    #endif
}


/*******************************************************************************
*  void SBCtrlEPServiceComplete(void)                                          *
*    ̃[`́AZbgAbvvɃT[rX񋟂                      *
*    ZbgAbvgUNV̗vʂɏ鏈              *
*******************************************************************************/
static void USBCtrlEPServiceComplete(void)
{
    // ZbgAbvgUNVMƂPKTDISrbgIɃZbgĂB
    // pPbgĊJ邽߂ɃNAASIEg[NуpPbg̏Lɂ
    UCONbits.PKTDIS = 0;

    // Check the busy bits SetupPtkmFARg[]̃^CvmKv܂B
    // pCv̏Ԃ`FbN
    if(inPipes[0].info.bits.busy == 0) {
        if(outPipes[0].info.bits.busy == 1) {
            // <SETUP[0]><OUT[1]><OUT[0]>... | <SETUP[0]?>

            controlTransferState = CTRL_TRF_RX;   // Rg[] yf[^Mz

            // f[^Xe[W̊Jn
            if(USBDeferOUTDataStagePackets == FALSE) {
                // EP0 OUT f[^Xe[W̃f[^ǂݏolɏ
                USBCtrlEPAllowDataStage();
            }

            //2.  IN EP0Xe[^XXe[W͉ɂĎ܂
            //    OUTf[^ׂ̂Ă̌USBCtrlEPAllowStatusStageijMAꂽA
            //    ^CAEgꍇɂĂ܂B
            USBStatusStageEnabledFlag2 = FALSE;
            USBStatusStageEnabledFlag1 = FALSE;
        } else {
            // SETUPgUNVMEP0Kv܂B
            pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
            pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
            pBDTEntryEP0OutNext->STAT.Val = _USIE|_DAT0|(_DTSEN & _DTS_CHECKING_ENABLED)|_BSTALL;
            // ̗v͏łȂ̂ŃXg[Ԃ
            pBDTEntryIn[0]->STAT.Val = _USIE|_BSTALL; 
        }
    } else {
        if(SetupPkt.DataDir == USB_SETUP_DEVICE_TO_HOST_BITFIELD) {
            // SETUPNGXg̃f[^]́AfoCXzXgł
            // <SETUP[0]><IN[1]><IN[0]>... | <SETUP[0]?>

            controlTransferState = CTRL_TRF_TX;   // Rg[] yf[^Mz

            // f[^Xe[W̊Jn
            if(USBDeferINDataStagePackets == FALSE) {
                USBCtrlEPAllowDataStage();
            }

            // zXgIsꍇA
            // ^CAEgꍇ(gUNVōŌɐEP0 IN50msj
            // Ȉ̂߂ɁAAXe[^XXe[WB
            USBStatusStageEnabledFlag2 = FALSE;
            USBStatusStageEnabledFlag1 = FALSE;
            if(USBDeferStatusStagePacket == FALSE) {
                USBCtrlEPAllowStatusStage();
            }
        } else {
            // SETUPNGXg̃f[^]́AzXgfoCXł
            // SET_ADDRESS / SET_CONFIGURATION
            //̏󋵂́AzXgSET_ADDRESS]𑗐MƂɔ̂
            //Rg[]Aȃ^Cv̂߂ɔ܂B
            //<SETUP[0]><IN[1]> | <SETUP[0]>

            controlTransferState = CTRL_TRF_RX;     //HOST_TO_DEVICẼRg[]ł

            //1. SETUPpPbgM邽߂EP0 OUTB
            pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
            pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
            pBDTEntryEP0OutNext->STAT.Val = _USIE|_BSTALL;

            //2. Rg[]̃Xe[^XXe[WIN̂߂̏
            USBStatusStageEnabledFlag2 = FALSE;
            USBStatusStageEnabledFlag1 = FALSE;
            if(USBDeferStatusStagePacket == FALSE) {
                USBCtrlEPAllowStatusStage();
            } 
        }
    }
}


/*******************************************************************************
*  void USBCtrlTrfTxService(void)                                              *
*    zXgɃRg[](INgUNV)ׂ̏                  *
*    PgUNV̑Mf[^acs(EP0 IN)ɃZbg܂B      *
*    ۂɂ́AINg[NM_SIEIɑMB               *
*******************************************************************************/
static void USBCtrlTrfTxService(void)
{
    BYTE byteToSend;

    byteToSend = USB_EP0_BUFF_SIZE;     // Mf[^̃ftHg͂WoCg

    // Mf[^͂WoCg菬H
    if(inPipes[0].wCount.Val < (BYTE)USB_EP0_BUFF_SIZE) {
        byteToSend = inPipes[0].wCount.Val;
        // V[gpPbg̑M󋵂Ǘ
        if(shortPacketStatus == SHORT_PKT_NOT_USED) {
            // Pڂ̑M͕ۗƂ(M鑍f[^ɂ蔼[͏o)
            shortPacketStatus = SHORT_PKT_PENDING;
        } else if(shortPacketStatus == SHORT_PKT_PENDING) {
            // V[gpPbg͑Mς
            shortPacketStatus = SHORT_PKT_SENT;
        }
    }

    // c̑MoCgvZĒu
    inPipes[0].wCount.Val = inPipes[0].wCount.Val - byteToSend;
    // 񑗐MoCgݒ肷A
    // őpPbgTCY͂USoCg܂łȂ̂ BC8 and BC9 rbg͏ɃNAŗǂł傤
    pBDTEntryIn[0]->CNT = byteToSend;

    // \[X̏ꏊf[^CtrlTrfData[]obt@փRs[AzXgɑM鏀s
    pDst = (USB_VOLATILE BYTE*)CtrlTrfData;                 // Rs[̃|C^ݒ
    if(inPipes[0].info.bits.ctrl_trf_mem == USB_EP0_ROM) {  // \[XROMɗL
        while(byteToSend) {
            *pDst++ = *inPipes[0].pSrc.bRom++;
            byteToSend--;
        }
    } else {                                                // \[XRAMɗL
        while(byteToSend) {
            *pDst++ = *inPipes[0].pSrc.bRam++;
            byteToSend--;
        }
    }
}


/*******************************************************************************
*  void USBCtrlTrfRxService(void)                                              *
*    foCX](OUTgUNVgp)̃zXgׂ̈Ɏgp֐ *
*                                                                              *
*  PreCondition:   pDst and wCount are setup properly.
*                  pSrc is always &CtrlTrfData usb_stat.ctrl_trf_mem is always USB_EP0_RAM.
*                  wCount should be set to 0 at the start of each control transfer.
*                  
*    ̊֐́AEP0 OUTɓf[^MAK؂outPipes[0].pDst.bRamobt@ɃRs[B
*    zXg炷ׂẴf[^MAK؂outPipes[0].PFUNC()nhĂяo܂B
*******************************************************************************/
static void USBCtrlTrfRxService(void)
{
    BYTE byteToRead;
    BYTE i;

    // OUTgUNVBDT̎Mf[^TCY𓾂
    byteToRead = pBDTEntryEP0OutCurrent->CNT;

    // zXgMf[^TCY\z菬Ȃ炻̃TCYMTCYƂ
    // ŌOUTgUNVɔł傤
    if(byteToRead > outPipes[0].wCount.Val) {
        byteToRead = outPipes[0].wCount.Val;
    }
    // c̃oCgvZ
    outPipes[0].wCount.Val = outPipes[0].wCount.Val - byteToRead;   

    // [UAvP[Vobt@ԂɁAzXgMOUT DATAxpPbgoCgRs[܂B
    for(i=0;i<byteToRead;i++) {
        *outPipes[0].pDst.bRam++ = CtrlTrfData[i];
    }

    if(outPipes[0].wCount.Val > 0) {
        // ܂Mf[^cĂꍇ
        // ꂪV[PX̎̃pPbgM邱Ƃł悤ɁAEP0 OUTpӁB
        pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
        pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&CtrlTrfData);
        if(pBDTEntryEP0OutCurrent->STAT.DTS == 0) {
            pBDTEntryEP0OutNext->STAT.Val = _USIE|_DAT1|(_DTSEN & _DTS_CHECKING_ENABLED);
        } else {
            pBDTEntryEP0OutNext->STAT.Val = _USIE|_DAT0|(_DTSEN & _DTS_CHECKING_ENABLED);
        }
    } else {
        // Ō̎Mf[^̏ꍇ
        // SETUPgUNVMׂEP0 OUT܂B
        pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
        pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
        // zXgM悤ƂĂ咣̃f[^𑗐M悤ƂꍇɃXg[ݒB
        pBDTEntryEP0OutNext->STAT.Val = _USIE|_BSTALL;

        // w肵R[obN֐Ăяo
        if(outPipes[0].pFunc != NULL) {
            #if defined(__XC8)
                //Special pragmas to suppress an expected/harmless warning
                //message when building with the XC8 compiler
                #pragma warning push
                #pragma warning disable 1088
                outPipes[0].pFunc();    //Call the user's callback function
                #pragma warning pop
            #else
                outPipes[0].pFunc();    //Call the user's callback function
            #endif
        }
        outPipes[0].info.bits.busy = 0;

        // Xe[^XXe[W̏s
        // Rg[]̎ނɉāÅ֐ 500ms/50ms/5s ƃ^C[ɌĂяoKvL
        // ڍׂ́AUSB2.0dl̃ZNV9.2.6QƂĂB
        if(USBDeferStatusStagePacket == FALSE) {
            USBCtrlEPAllowStatusStage();
        }
    }
}


/*******************************************************************************
*  void USBStdSetCfgHandler(void)                                              *
*    SET_CONFIGURATIOÑpPbgɏ֐                       *
*    pGh|Cg̏ƊeNXŗL̏                      *
*******************************************************************************/
static void USBStdSetCfgHandler(void)
{
    BYTE i;

    // rW[ԂɂÁA[̃pPbg𐶐܂(Xe[^XXe[WԐM̈)
    inPipes[0].info.bits.busy = 1;
    // Gh|Cg䃌WX^(EP1/EP2)NA
    memset((void*)&UEP1,0x00,USB_MAX_EP_NUMBER) ;
    // obt@ fBXNv^ e[u(EP0/EP1/EP2)NA
    memset((void*)&BDT[0], 0x00, sizeof(BDT));
    // s|obt@|C^̑SĂɃZbgv
    USBPingPongBufferReset = 1;
    // f[^̃obt@ւ̃|C^[NA
    for(i = 0; i < (BYTE)(USB_MAX_EP_NUMBER+1u); i++) {
        ep_data_in[i].Val  = 0u;
        ep_data_out[i].Val = 0u;
    }
    // I^l[gC^[tFCXݒNA
    memset((void*)&USBAlternateInterface,0x00,USB_MAX_NUM_INT);
    //s|obt@|C^Zbglɐݒ
    USBPingPongBufferReset = 0;

    // ŏ́AdoO̓͂ŋ̂acsւ̃Gg[|C^lŐݒ
    pBDTEntryIn[0] = (volatile BDT_ENTRY*)&BDT[EP0_IN_EVEN];
    // ŏ́AdoȌo͂ŋ̂acsւ̃Gg[|C^lŐݒ
    pBDTEntryEP0OutCurrent = (volatile BDT_ENTRY*)&BDT[EP0_OUT_EVEN];
    pBDTEntryEP0OutNext = pBDTEntryEP0OutCurrent;

    // MRtBM[VfBXNv^̃CfbNXԍݒ肷
    USBActiveConfiguration = SetupPkt.bConfigurationValue;
    if(USBActiveConfiguration == 0) {
        // USBfoCX̏ԂAhX̐ݒIԂɖ߂
        USBDeviceState = ADDRESS_STATE;
    } else {
        // [U[CxgR[obN֐ɓn
        // pGh|Cg(EP0ȊO)̏ƊeNXŗL̏ōsĂ
        USER_USB_CALLBACK_EVENT_HANDLER(EVENT_CONFIGURED,(void*)&USBActiveConfiguration,1);

        // USBfoCX̏ԂRtBM[V̐ݒIԂɂ
        USBDeviceState = CONFIGURED_STATE;
    }
}


/*******************************************************************************
*  void USBStdGetDscHandler(void)                                              *
*    WGET_DESCRIPTORv܂                                        *
*    w肳ꂽfBXNv^Ԃ(EP0 IN ̃pCvɃf[^Zbg)       *
*******************************************************************************/
static void USBStdGetDscHandler(void)
{
    // NGXg^Cv[foCXzXg]][WNGXg][foCXM]
    if(SetupPkt.bmRequestType == 0x80) {
        // pCv̏ݒA[f[^RAM]][rW[ԂƂ][[̃pPbg܂]
        inPipes[0].info.Val = USB_EP0_ROM | USB_EP0_BUSY | USB_EP0_INCLUDE_ZERO;

        switch(SetupPkt.bDescriptorType)
        {
            case USB_DESCRIPTOR_DEVICE:           // foCXfBXNv^Ԃ
                #if !defined(USB_USER_DEVICE_DESCRIPTOR)
                    inPipes[0].pSrc.bRom = (ROM BYTE*)&device_dsc;
                #else
                    inPipes[0].pSrc.bRom = (ROM BYTE*)USB_USER_DEVICE_DESCRIPTOR;
                #endif
                inPipes[0].wCount.Val = sizeof(device_dsc);
                break;
            case USB_DESCRIPTOR_CONFIGURATION:    // RtBM[VfBXNv^Ԃ
                #if !defined(USB_USER_CONFIG_DESCRIPTOR)
                    inPipes[0].pSrc.bRom = *(USB_CD_Ptr+SetupPkt.bDscIndex);
                #else
                    inPipes[0].pSrc.bRom = *(USB_USER_CONFIG_DESCRIPTOR+SetupPkt.bDscIndex);
                #endif
                inPipes[0].wCount.byte.LB = *(inPipes[0].pSrc.bRom+2);
                inPipes[0].wCount.byte.HB = *(inPipes[0].pSrc.bRom+3);
                break;
            case USB_DESCRIPTOR_STRING:           // XgOfBXNv^Ԃ
                // ṽXgOXԍ́AXgOfBXNv^̌ȓ`FbN
                if(SetupPkt.bDscIndex < USB_NUM_STRING_DESCRIPTORS) {
                    inPipes[0].pSrc.bRom = *(USB_SD_Ptr+SetupPkt.bDscIndex);
                    inPipes[0].wCount.Val = *inPipes[0].pSrc.bRom;
                } else {
                    // ṽXgOXԍ͎ĂȂI
                    inPipes[0].info.Val = 0;
                }
                break;
            default:
                inPipes[0].info.Val = 0;
                break;
        }
    }
}


/*******************************************************************************
*  void USBStallHandler(void)                                                  *
*    STALL̃Cxgɏ                                         *
*    foCXs\ȏԂ̎ɂ́ASTALLԐM܂                     *
*******************************************************************************/
static void USBStallHandler(void)
{
    // EP0ŃXg[𔭍sꍇɁABD ̃I[i SIE ̎AL CPU ɖ߂
    if(UEP0bits.EPSTALL == 1) {    // EP0 ŃXg[𔭍s
        // (EP0 OUT  BD  owned by SIE)  (EP0 IN  BD  owned by SIE) ŗL
        if((pBDTEntryEP0OutCurrent->STAT.Val == _USIE) && (pBDTEntryIn[0]->STAT.Val == (_USIE|_BSTALL))) {
            // DATA0pPbgAf[^gOLAobt@Xg[L Iɐݒ肷
            pBDTEntryEP0OutCurrent->STAT.Val = _USIE|_DAT0|(_DTSEN & _DTS_CHECKING_ENABLED)|_BSTALL ;
        }
        UEP0bits.EPSTALL = 0;      // EP0Xg[tONA
    }

    UIRbits.STALLIF = 0 ;          // STALL nhVFCN荞݃tONA
}


/*******************************************************************************
*  void USBSuspend(void)                                                       *
*    zXgAChԂɈڍsꍇɌďo鏈                        *
*    Ӂj UIRbits.ACTVIF NAȂł                      *
*******************************************************************************/
static void USBSuspend(void)
{
    UIEbits.ACTVIE  = 1 ;          // ANeBreBo荞݂
    UIRbits.IDLEIF  = 0 ;          // AChԂ̌o荞݃tONA
    // USBW[ƎӉHȓd̓[hɂSIE ̃NbN~
    UCONbits.SUSPND = 1;

    // zXg̓TXyhԂɗLƃtO𗧂Ă
    USBBusIsSuspended = TRUE ;

    // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
    // [U[̉H/foCXȓd͂Ɉڍsꍇ́AUSBCBSuspend()֐ōs
    USB_SUSPEND_HANDLER(EVENT_SUSPEND,0,0);
}


/*******************************************************************************
*  void USBWakeFromSuspend(void)                                               *
*    USBTXyh̃EFCNAbvoꂽꍇɌďo鏈         *
*******************************************************************************/
static void USBWakeFromSuspend(void)
{
    USBBusIsSuspended = FALSE;     // zXgTXyh[hł͖Ɛݒ

    // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
    USB_WAKEUP_FROM_SUSPEND_HANDLER(EVENT_RESUME,0,0);
    // USBW[ƎӉHʏ퓮ɂASIE ̃NbNݒς݂̃[gɂ
    UCONbits.SUSPND = 0;
    // oX ANeBreBo荞݂֎~ɂ
    UIEbits.ACTVIE = 0;
    // ANeBreBotONA
    while(UIRbits.ACTVIF) {
        UIRbits.ACTVIF = 0 ;
    }
}


/*******************************************************************************
*  void USBCtrlEPService(void)                                                 *
*    EP0ɑ΂ăgUNVICxg(TRNIF)ɏ֐  *
*  Tv: ȉ̂R^CvgUNVp̊֐            @                  *
*        1. EP0 SETUP pPbg                                                 *
*        2. EP0 OUT   pPbg                                                 *
*        3. EP0 IN    pPbg                                                 *
*        ȊÔׂẴ^Cv͖ (i.e. EP1, EP2, etc.)                *
*******************************************************************************/
static void USBCtrlEPService(void)
{
    unsigned char setup_cnt;

    //If we get to here, that means a successful transaction has just occurred 
    //on EP0.  This means "progress" has occurred in the currently pending 
    //control transfer, so we should re-initialize our timeout counter.
    #if defined(USB_ENABLE_STATUS_STAGE_TIMEOUTS)
        // ^CAEgJE^ď
        USBStatusStageTimeoutCounter = USB_STATUS_STAGE_TIMEOUT;      // (BYTE)45
    #endif

    // ĨgUNV EP0OUTobt@ USTAT WX^̃`FbNs
    if((USTATcopy.Val & USTAT_EP0_PP_MASK) == USTAT_EP0_OUT_EVEN) {
        // EP0 OUTBDT e[uւ̃|Cgs
        pBDTEntryEP0OutCurrent = (volatile BDT_ENTRY*)&BDT[(USTATcopy.Val & USTAT_EP_MASK)>>1];

        // ݂̃|Cg̃|Cgɐݒ肷
        pBDTEntryEP0OutNext = pBDTEntryEP0OutCurrent;
        // f[^gOrbg(DATA0/1 pPbg)𔽓]
        ((BYTE_VAL*)&pBDTEntryEP0OutNext)->Val ^= USB_NEXT_EP0_OUT_PING_PONG;

        // ݂EP0 OUTBDTXe[^XWX^̃pPbgID rbg𒲂ׂ
        if(pBDTEntryEP0OutCurrent->STAT.PID == PID_SETUP) { //ySETUPpPbgz
            // SetupPktobt@SETUPf[^Rs[
            for(setup_cnt = 0; setup_cnt < 8u; setup_cnt++) {
                // SETUPf[^pPbǵAɐm8oCg܂܂Ă܂B
                *(BYTE*)((BYTE*)&SetupPkt + setup_cnt) = *(BYTE*)ConvertToVirtualAddress(pBDTEntryEP0OutCurrent->ADR);
                pBDTEntryEP0OutCurrent->ADR++;
            }
            pBDTEntryEP0OutCurrent->ADR = ConvertToPhysicalAddress(&SetupPkt);
            // Rg[]iZbgAbvR}h͂j
            USBCtrlTrfSetupHandler();
        } else {                //yOUTpPbg:f[^MzoryINpPbg:Xe[^XXe[Wz
            // f[^]
            USBCtrlTrfOutHandler();
        }
    } else {
        // zXgւ̃f[^Mꍇɏ
        // Ō̃gUNV EP0INobt@`FbNs
        if((USTATcopy.Val & USTAT_EP0_PP_MASK) == USTAT_EP0_IN) {
            USBCtrlTrfInHandler();
        }
    }
}


/*******************************************************************************
*  void USBCtrlTrfSetupHandler(void)                                           *
*    rdstopPbg̏s֐                                *
*  Note: Rg[]Xe[g}V3̈قȂԂLĂB         *
*        1. WAIT_SETUP                                                         *
*        2. CTRL_TRF_TX (INgUNVăzXgɃf[^𑗐M)       *
*        3. CTRL_TRF_RX (OUTgUNVăzXgf[^M)    *
*                                                                              *
*        Rg[]́AUSBgUNV\ĂB     *
*        ̃gUNVăf[^]ꍇA                  *
*        f[^\[XAf[^Aуf[^c邱ƂdvłB  *
*        3̃p[^pSrcpDstɁAwCountɊi[ĂB   *
*        tÓAf[^\[XROMRAM̕łꍇɒӂׂɎgpB
*******************************************************************************/
static void USBCtrlTrfSetupHandler(void)
{
    // ]𐧌䂷邽߂ɁA֘AԂ̃gbLOϐď܂B
    shortPacketStatus           = SHORT_PKT_NOT_USED;
    USBDeferStatusStagePacket   = FALSE;
    USBDeferINDataStagePackets  = FALSE;
    USBDeferOUTDataStagePackets = FALSE;
    BothEP0OutUOWNsSet          = FALSE;
    controlTransferState        = WAIT_SETUP;                         // Rg[]̓]ԂAChɐݒ
    // IN  BDTe[u
    pBDTEntryIn[0]->STAT.Val &= ~(_USIE);                             // UOWNrbgNA(CPU)
    ((BYTE_VAL*)&pBDTEntryIn[0])->Val ^= USB_NEXT_EP0_IN_PING_PONG;   // f[^gOrbg(DATA1 pPbg)
    pBDTEntryIn[0]->STAT.Val &= ~(_USIE);                             // ??(̍sƓƎv邪)
    ((BYTE_VAL*)&pBDTEntryIn[0])->Val ^= USB_NEXT_EP0_IN_PING_PONG;   // ??(s|obt@̐ؑւH)
    // OUT  BDTe[u
    pBDTEntryEP0OutNext->STAT.Val &= ~(_USIE);

    inPipes[0].info.Val = 0;
    inPipes[0].wCount.Val = 0;
    outPipes[0].info.Val = 0;
    outPipes[0].wCount.Val = 0;

    // SETUPpPbg̕WNGXg(USB "Chapter 9" requests)ɉes
    USBCheckStdRequest();

    // [U[CxgR[obN֐ɓn
    // eNXŗL̃NGXgƒʒm̗v͂ŏ
    USER_USB_CALLBACK_EVENT_HANDLER(EVENT_EP0_REQUEST,0,0);

    // NGXgɑ΂Ď̓(f[^̑MȂ)΂ŏ
    USBCtrlEPServiceComplete();
}


/*******************************************************************************
*  void USBCtrlTrfOutHandler(void)                                             *
*    Rg[]ԂɉOUTgUNV֐             *
*******************************************************************************/
static void USBCtrlTrfOutHandler(void)
{
    if(controlTransferState == CTRL_TRF_RX) {
        // OUTgUNV̓f[^Xe[W̎MŗLꍇ
        // K؂ȃobt@ɐVɎMf[^Rs[ÃgUNV̂߂EP0 OUTݒ肵܂B
        // <SETUP><OUT><OUT>...<OUT>
        USBCtrlTrfRxService();	
    } else {
        // OUTgUNV̓Xe[^XXe[WŗLꍇ
        // <SETUP><IN><IN>...<OUT>傤ǃXe[^XXe[WƂĔ̍ŌOUT

        // Rg[]̓]ԂAChɐݒ
        controlTransferState = WAIT_SETUP;

        if(BothEP0OutUOWNsSet == FALSE) {
            // SETUPgUNVEP0 OUTpӂ
            pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
            pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
            pBDTEntryEP0OutNext->STAT.Val = _USIE|_DAT0|(_DTSEN & _DTS_CHECKING_ENABLED)|_BSTALL;			
        } else {
            BothEP0OutUOWNsSet = FALSE;
        }
    }
}


/*******************************************************************************
*  void USBCtrlTrfInHandler(void)                                              *
*    zXgւ̃f[^Mꍇɏ                            *
*    Xe[^XXe[W̊́AIԂɂ                    *
*    EP0 INłPf[^ḾÃf[^Mł悤ɃZbg      *
*  Note:AhXݒvRg[]܂ŁA                     *
*       foCX̂́Aۂ̃AhXύXȂłB               *
*       AhXݒvɑ΂Rg[]̏ÍAINgUNVłB
*       āAɁÃj[Nȏ󋵂ׂɕKvłB
*       }NmUSBCheckAdrPendingStateusb9.hŒ`A                     *
*       ̋@\́AɁÃCxg邽߂ɂłB                   *
*******************************************************************************/
static void USBCtrlTrfInHandler(void)
{
    BYTE lastDTS;

    // O񑗐M̃f[^gOrbg(DATA0/1)Rs[Ēu
    lastDTS = pBDTEntryIn[0]->STAT.DTS;

    // ̃s|obt@ɐ؂ւ(DTS̐ؑւH)
    ((BYTE_VAL*)&pBDTEntryIn[0])->Val ^= USB_NEXT_EP0_IN_PING_PONG;

    // y USBfoCX̏ԁFAhXݒۗ z
    if(USBDeviceState == ADR_PENDING_STATE) {
        UADDR = SetupPkt.bDevADR.Val;             // USBfoCXAhXWX^ɃAhXݒ
        if(UADDR != 0u) {
            USBDeviceState=ADDRESS_STATE;         // USBfoCX̏ԂAhXݒ芮Ƃ
        } else {
            USBDeviceState=DEFAULT_STATE;         // USBfoCX̏ԂftHgԂƂ
        }
    }

    if(controlTransferState == CTRL_TRF_TX) {     // yRg[]ԁFf[^Mz
        // ̃f[^PgUNVMׂɃf[^ BDT EP0 IN ɃZbg
        // Zbgf[^́AINg[NM_SIEIɑMB
        pBDTEntryIn[0]->ADR = ConvertToPhysicalAddress(CtrlTrfData);
        USBCtrlTrfTxService();

        if(shortPacketStatus == SHORT_PKT_SENT) {
            // ɃV[gpPbg͑Mς݂IAzXgSTALL𑗂
            pBDTEntryIn[0]->STAT.Val = _USIE|_BSTALL;
        } else {
            // OƈقȂf[^gOrbgőM
            if(lastDTS == 0) {
                pBDTEntryIn[0]->STAT.Val = _USIE|_DAT1|(_DTSEN & _DTS_CHECKING_ENABLED);
            } else {
                pBDTEntryIn[0]->STAT.Val = _USIE|_DAT0|(_DTSEN & _DTS_CHECKING_ENABLED);
            }
        }
    } else {                                      // yRg[]ԁFf[^Mz
        // (<setup><out><out>...<IN>  <-- IN̍Ō̂͒PȂXe[^XXe[WƂĔ
        // f[^MXe[W͓rłIƂȂ钍
        // Xe[^XXe[WM
        if(outPipes[0].info.bits.busy == 1)
        {
            if(outPipes[0].pFunc != NULL)
            {
                outPipes[0].pFunc();
            }
            outPipes[0].info.bits.busy = 0;
        }
    	
        controlTransferState = WAIT_SETUP;
    }
}


/*******************************************************************************
*  void USBCheckStdRequest(void)                                               *
*    SETUPpPbg̃NGXgɉeɕ򂳂֐                   *
*******************************************************************************/
static void USBCheckStdRequest(void)
{
    // SETUPpPbg̃NGXgWNGXgłȂȂ珈Ȃ
    if(SetupPkt.RequestType != USB_SETUP_TYPE_STANDARD_BITFIELD) return;

    switch(SetupPkt.bRequest)
    {
        case USB_REQUEST_SET_ADDRESS:             // foCX̃AhXݒ
            // rW[ԂɂÁA[̃pPbg𐶐܂(Xe[^XXe[WԐM̈)
            inPipes[0].info.bits.busy = 1;
            // USBfoCX̏ԂAhXݒۗɂ
            // SET_ADDRESSR}hMA܂STATUSXe[WIĂȂׂɎgp
            USBDeviceState = ADR_PENDING_STATE;
            /* AhX͂̌ USBCtrlTrfInHandler() ֐ŃZbg */
            break;
        case USB_REQUEST_GET_DESCRIPTOR:          // w̃fXNv^Ԃ
            // WGET_DESCRIPTORv܂
            USBStdGetDscHandler();
            break;
        case USB_REQUEST_SET_CONFIGURATION:       // RtBM[Vݒ
            // pGh|Cg̏ƊeNXŗL̏܂
            USBStdSetCfgHandler();
            break;

        case USB_REQUEST_CLEAR_FEATURE:           // ̋@\NABXg[Ȃ
        case USB_REQUEST_SET_FEATURE:             // [gEFBNAbvȂǂ̋@\ݒ
            USBStdFeatureReqHandler();
            break;
        case USB_REQUEST_SET_DESCRIPTOR:          // fBXNv^ύX
            // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
            USER_USB_CALLBACK_EVENT_HANDLER(EVENT_SET_DESCRIPTOR,0,0);
            break;
        case USB_REQUEST_GET_STATUS:              // Gh|Cg̃Xe[^XԂ
        case USB_REQUEST_GET_CONFIGURATION:       // foCX݂̌̃RtBO[VlԂ
        case USB_REQUEST_GET_INTERFACE:           // ݂̑ւC^tF[XԍԂ
        case USB_REQUEST_SET_INTERFACE:           // ւC^tF[Xݒ
        case USB_REQUEST_SYNCH_FRAME:             // p^[̃AC\NiX]ŎgpAp^[Jnԍ擾v
        default:
            break;
    }
}


/*******************************************************************************
*  void USBStdFeatureReqHandler(void)                                          *
*    SET_FEATURE/CLEAR_FEATUREv̕WZbgNA֐           *
*    BDTGg̕ύXA܂AUSBX^bNێϐύX邱Ƃł܂B    *
*    USBX^bNɂēŎgpׂɈӐ}ꂽvCx[g֐ł *
*    foCXւSET/CLEAR@\"TEST_MODE"͑ΉĂȂB                *
*    C^[tFCXւSET/CLEAR@\́A݂USB2.0dlɂėp͖B *
*******************************************************************************/
static void USBStdFeatureReqHandler(void)
{
    BDT_ENTRY *p;
    EP_STATUS current_ep_data;
    unsigned char* pUEP;

    //zXgfoCXւSET/CLEAR@\i[gEFCNAbvjv𑗐MǂmF܂B
    if((SetupPkt.bFeature == USB_FEATURE_DEVICE_REMOTE_WAKEUP)&&
       (SetupPkt.Recipient == USB_SETUP_RECIPIENT_DEVICE_BITFIELD))
    {
        // rW[ԂɂÁA[̃pPbg𐶐܂(Xe[^XXe[WԐM̈)
        inPipes[0].info.bits.busy = 1;
        // "SET_FEATURE"Ȃ烊[gEFCNAbvtOLƂ
        if (SetupPkt.bRequest == USB_REQUEST_SET_FEATURE) {
             RemoteWakeup = TRUE;
        } else {
             RemoteWakeup = FALSE;
        }
    }


    //zXgGh|CgւSET/CLEAR@\iGh|Cg̒~jv𑗐MǂmF܂B
    if((SetupPkt.bFeature == USB_FEATURE_ENDPOINT_HALT)&&
       (SetupPkt.Recipient == USB_SETUP_RECIPIENT_ENDPOINT_BITFIELD)&&
       (SetupPkt.EPNum != 0) && (SetupPkt.EPNum <= USB_MAX_EP_NUMBER)&&
       (USBDeviceState == CONFIGURED_STATE))
    {
        // rW[ԂɂÁA[̃pPbg𐶐܂(Xe[^XXe[WԐM̈)
        inPipes[0].info.bits.busy = 1;

        //zXgSET/CLEARsBDT(IN/OUT)ւ̃|C^擾܂B
        if(SetupPkt.EPDir == OUT_FROM_HOST) {
            p = (BDT_ENTRY*)pBDTEntryOut[SetupPkt.EPNum];
            current_ep_data.Val = ep_data_out[SetupPkt.EPNum].Val;
        } else {
            p = (BDT_ENTRY*)pBDTEntryIn[SetupPkt.EPNum];
            current_ep_data.Val = ep_data_in[SetupPkt.EPNum].Val;
        }
        // s|obt@Ow̃Gh|CgŗLɂȂĂꍇ́ABDTɐi߂鏈s
        #if (USB_PING_PONG_MODE == USB_PING_PONG__ALL_BUT_EP0) || (USB_PING_PONG_MODE == USB_PING_PONG__FULL_PING_PONG)
            if(current_ep_data.bits.ping_pong_state == 0) {
                USBHALPingPongSetToEven(&p);
            } else {
                USBHALPingPongSetToOdd(&p);
            }
        #endif

        // VÃGgBDT|C^XV܂
        if(SetupPkt.EPDir == OUT_FROM_HOST) {
            pBDTEntryOut[SetupPkt.EPNum] = (volatile BDT_ENTRY *)p;
        } else {
            pBDTEntryIn[SetupPkt.EPNum]  = (volatile BDT_ENTRY *)p;
        }

        if(SetupPkt.bRequest == USB_REQUEST_SET_FEATURE) {
            // "SET_FEATURE" Gh|Cg~v
            if(p->STAT.UOWN == 1) {
                // BDT̃I[iSIE]I
                if(SetupPkt.EPDir == OUT_FROM_HOST) {
                    ep_data_out[SetupPkt.EPNum].bits.transfer_terminated = 1;
                } else {
                    ep_data_in[SetupPkt.EPNum].bits.transfer_terminated = 1;
                }
            }
            // Xg[̒ʒmݒ肷
            p->STAT.Val |= _USIE|_BSTALL;
        } else {
            // "CLEAR_FEATURE" Gh|Cgv(STALL)
            #if (USB_PING_PONG_MODE == USB_PING_PONG__ALL_BUT_EP0) || (USB_PING_PONG_MODE == USB_PING_PONG__FULL_PING_PONG)
                // s|obt@Ow̃Gh|CgŗLɂȂĂꍇ
                USBAdvancePingPongBuffer(&p);
                // USBTransferOnePacket()gDATA1DTSݒ肷
                if(p->STAT.UOWN == 1) {
                    p->STAT.Val &= (~_USIE);    //Clear UOWN bit
                    p->STAT.Val |= _DAT1;       //Set DTS to DATA1
                    // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
                    USER_USB_CALLBACK_EVENT_HANDLER(EVENT_TRANSFER_TERMINATED,p,sizeof(p));
                } else {
                    p->STAT.Val |= _DAT1;
                }

                //toggle back to the active BDT (the one the SIE is currently looking at
                //and will use for the next successful transaction to take place on the EP
                USBAdvancePingPongBuffer(&p);    
                
                //Check if we are currently terminating, or have previously terminated
                //a transaction on the given endpoint.  If so, need to clear UOWN,
                //set DTS to the proper state, and call the application callback
                //function.
                if((current_ep_data.bits.transfer_terminated != 0) || (p->STAT.UOWN == 1)) {
                    if(SetupPkt.EPDir == OUT_FROM_HOST) {
                        ep_data_out[SetupPkt.EPNum].bits.transfer_terminated = 0;
                    } else {
                        ep_data_in[SetupPkt.EPNum].bits.transfer_terminated = 0;
                    }
                    //clear UOWN, clear DTS to DATA0, and STALL폜
                    p->STAT.Val &= ~(_USIE | _DAT1 | _BSTALL);  
                    // [U[CxgR[obN֐ɓn(݂͉ĂȂ)
                    USB_TRANSFER_TERMINATED_HANDLER(EVENT_TRANSFER_TERMINATED,p,sizeof(p));
                } else {
                    //clear UOWN, clear DTS to DATA0, and STALL폜
                    p->STAT.Val &= ~(_USIE | _DAT1 | _BSTALL); 
                }
            #else
                // s|obt@Ow̃Gh|CgŖɂȂĂꍇ
                //else we must not be using ping-pong buffering on the requested endpoint
                //Check if we need to call the user transfer terminated event callback function.
                //We should call the callback, if the endpoint was previously terminated,
                //or the endpoint is currently armed, and the host is performing clear
                //endpoint halt, even though the endpoint wasn't stalled.
                if((current_ep_data.bits.transfer_terminated != 0) || (p->STAT.UOWN == 1)) {
                    //We are going to call the user transfer terminated callback.
                    //Clear the flag so we know we took care of it and don't need
                    //to call it again later.
                    if(SetupPkt.EPDir == OUT_FROM_HOST) {
                        ep_data_out[SetupPkt.EPNum].bits.transfer_terminated = 0;
                    } else {
                        ep_data_in[SetupPkt.EPNum].bits.transfer_terminated = 0;
                    }
 
                    // UOWNNAASTALLԂ폜܂B
                    // USBTransferOnePacket()ĂяoDATA0ɐ؂ւ܂悤ɁA
                    // DTSrbgݒ肷KvLB
                    p->STAT.Val &= ~(_USIE | _BSTALL);  
                    p->STAT.Val |= _DAT1;
                    //Let the application firmware know a transaction just
                    //got terminated by the host, and that it is now free to
                    //re-arm the endpoint or do other tasks if desired.                                        
                    USB_TRANSFER_TERMINATED_HANDLER(EVENT_TRANSFER_TERMINATED,p,sizeof(p));
                } else {
                    // UOWNNAASTALLԂ폜܂B
                    // USBTransferOnePacket()ĂяoDATA0ɐ؂ւ܂悤ɁA
                    // DTSrbgݒ肷KvLB
                    p->STAT.Val &= ~(_USIE | _BSTALL);  
                    p->STAT.Val |= _DAT1;
                } 
            #endif

            //Get a pointer to the appropriate UEPn register
            pUEP = (unsigned char*)(&U1EP0+SetupPkt.EPNum);
            //Clear the STALL bit in the UEP register
            *pUEP &= ~UEP_STALL;            
        }
    }
}
